//**************************************************************************
//**
//** kaiser_21-map00.acs : poedDoom
//**$Revise Date: 11/28/06
//**$Author: kaiser
//**$Description: level script
//**
//**************************************************************************
#library "sc_m00"
#include "cif3_main.c"

str lvlMus[64] = {
	"D_INTRO",
	"D_BETWEE",
	"D_OHOH",
	"D_ZDOOM1",
	"D_ZDOOM2",
	"D_HOME",
	"D_MAP10",
	"D_M11",
	"D_SEC",
	"D_M14",
	"D_M15",
	"D_M16",
	"D_M17",
	"D_M18",
	"D_M19",
	"D_HEH1",
	"D_HEH2",
	"D_HEH3",
	"D_READY",
	"D_VSDRON",
	"D_WEWON?",
	"D_M27",
	"D_M28",
	"D_M31",
	"D_NEWB",
	"D_BROKE",
	"D_ULTIMA",
	"D_M41",
	"D_OHSHI",
	"D_EDBOSS",
	"D_DRON",
	"D_EDWARD",
	"D_WAR",
	"D_HURRAY",
	"D_TROUBL",
	"D_WMULL",
	"D_GNEWT",
	"D_ADMIN",
	"D_BATTLE",
	"D_BOSS1",
	"D_BYEBYE",
	"D_TSTMAP",
	"D_XMIX01",
	"D_XMIX02",
	"D_XMIX03",
	"D_XMIX04",
	"D_XMIX05",
	"D_XMIX06",
};

int musSwitch = 0;

function int sqrt (int x) {
	int r;
	x = x + 1 >> 1;
	while (x > r)
		x -= r++;
	return r;
}

script 1 (void) {
	SetMusic(lvlMus[musSwitch]);
	printbold(s: lvlMus[musSwitch]);
	musSwitch = musSwitch + 1 & 63;
}

script 2 (void) {
	DialogInit();
}

script 3 (int blah) {
}

script 4 (void) {
	while(1) {
		printbold(i: VectorAngle(plyrX, plyrY));
		delay(1);
	}
}

script 5 (int i) {
	printbold(i:GetLineAngle(i));
}

script 6 (int i) {
	while(1) {
		if(CheckLineAngle(plyrX, plyrY, plyrAngle, i) == true)
			printbold(s: "Yup..");
		else printbold(s: "No..");
		delay(1);
	}
}

script 7 (int i) {
	printbold(i: toByte((plyrAngle>>8) + i));
}

script 8 (void) {
	Thing_Activate(6);
	Thing_SetGoal(6, 7, 0, 1);
}

script 9 (void) {
	Thing_Activate(6);
	Thing_SetGoal(6, 0, 0, 0);
}

script 10 (void) {
	RegisterMobj();
}

script 11 (int i) {
	printbold(i: GetStack());
	printbold(i: _T(i));
	printbold(i: _Health(i));
	printbold(i: _Type(i));
	printbold(i: _TAG(i));
}

script 12 (void) {

	Thing_Hate(_T(_I()), 0, TARG_FINDNOW);
	A_FaceTarget(_I(), 0);
}

script 13 (void) {
}

script 14 (void) {
	A_SpawnInFront(plyrX, plyrY, plyrZ+8<<16, "Rocket2", plyrAngle, 0, 8);
}

script 15 (int blah) {
	if(!blah)
		Spawn("AllyTargetTest", -1728<<16, -256<<16, 0, 0, 192);
	else
		Spawn("MarineAlly_Test", -1472<<16, -640<<16, 0, 0, 0);
}

script 16 (void) {
	while(1) {
		printbold(i: A_GetDistance(plyrX, GetActorX(6), plyrY, getActorY(6)),
			s: " ", i: A_GetDistanceZ(plyrZ, getActorZ(6)));
		delay(1);
	}
}

script 17 (int t) {
	while(1) {

		if(A_CheckFOV(plyrX, plyrY, GetActorX(t), GetActorY(t), plyrAngle, 32))
			printbold(s: "Yup");
		else printbold(s: "No");

		delay(1);
	}
}

script 18 (int t) {
	A_FaceTarget(t, 0);
}

script 19 (int t, int th, int thDir) {
	A_Strafe(t, 0, 1, random(0, 1), th, 4, thDir);
}

script 20 (int t) {
	while(1) {
		printbold(i: A_GetFOVRange(plyrX, plyrY, GetActorX(t), GetActorY(t), plyrAngle));
		delay(1);
	}
}

script 21 (int t) {
	while(1) {
		if(A_CheckPlayerTarget(t, 24, 32) == true)
			printbold(s: "Yes");
		else printbold(s: "No");

		delay(1);
	}
}

script 22 (int t) {
	int result = A_GetFOVRange(plyrX, plyrY, GetActorX(t), GetActorY(t), plyrAngle);
	if(result >= 128) {
		A_FaceTarget(t, 0);
		ThrustThing((GetActorAngle(t)>>8) - 64, 2, 0, t);
		A_FaceTarget(t, 0);
	}
	else if(result < 128) {
		A_FaceTarget(t, 0);
		ThrustThing((GetActorAngle(t)>>8) + 64, 2, 0, t);
		A_FaceTarget(t, 0);
	}
}

script 23 (int t) {
	while(1) {
		printbold(i: A_GetFOVRange(plyrX, plyrY, GetActorX(t), GetActorY(t), plyrAngle),
		s: " ",
		i: A_GetFOVRange(GetActorX(t), GetActorY(t), plyrX, plyrY, GetActorAngle(t)));
		delay(1);
	}
}

script 24 (int t) {
	printbold(i: GetActorProperty(t, APROP_Speed),
	s: " ",
	i: GetActorProperty(0, APROP_Speed));
}

script 25 (int t) {
	while(1) {
		printbold(i: A_GetDistance(plyrX, GetActorX(t), plyrY, GetActorY(t)));
		delay(1);
	}
}

script 26 (int t) {
	int x = 0;

	while(1) {;
		Spawn("LaserTest", 0, x, 0, 0, 0);
		x = x + 1.5;
		delay(1);
	}
}

//give weapons back
script LVLLOAD (void) {
	int i;
	if(weaponNum == 0) {
		weaponNum = 1023;
		GiveInventory("CleaverSpecial", 1);
		GiveInventory("PanSpecial", 1);
		GiveInventory("ShockSpecial", 1);
		GiveInventory("FlameSpecial", 1);
		GiveInventory("SnipeSpecial", 1);
		GiveInventory("RocketSpecial", 1);
		GiveInventory("MeatGunSpecial", 1);
		GiveInventory("JetPack", 1);
		GiveInventory("Coin", 1000000);
	}

	while(i != 10) {
		if(findWeapon(weaponNum, Iweapons[i])) {
			GiveInventory(Xweapons[i], 1);
		}
		i++;
		delay(1);
	}
	
}

script LVLMAIN OPEN
{
	int i;
	ACS_Execute(253, 0, 0, 0, 0);
}