//**************************************************************************
//**
//** kaiser_21-map08.acs : poedDoom
//**$Revise Date: 02/26/06
//**$Author: kaiser
//**$Description: level script
//**
//**************************************************************************
#library "sc_m08"
#include "cif3_main.c"

int mapvar1 = 0;
int mapvar2 = 0;
int mapvar3 = 0;
int mapvar5 = 0;
int questVar = 0;
#define Arena_Max_X -2208
#define Arena_Min_X -1120
#define Arena_Max_Y  2016
#define Arena_Min_Y 1056
str arena[6] = {"NewbMeleeFast", "NewbMelee", "NewbMeleeFast", "NewbMeleeStrong", "NewbMissle",
"NewbMeleeFast"};
int spamBots1[4] = {190, 199, 188, 195};
int spamBots2[4] = {194, 205, 194, 205};

script 1(void)
{
	if(mapvar3 == 0 && CheckInventory("SpecialItem4"))
	{
		mapvar3++;
		Door_Close(225, 128);
		AmbientSound("weapons/rocklx", 127);
		Radius_Quake (5, 4*35, 0, 64, 8);
		setmusic("D_ATTACK");
		Thing_Remove(7);
		Thing_Spawn(11, 187, 0);
		Thing_Spawn(12, 186, 0);
		ACS_Execute(2, 0, 0, 0, 0);
		delay(1);
		GiveInventory("RaiseAlarm", 1);
		Door_Open(2, 16);
		printbold(s:"Doomworld/#Zdoom is under attack!");
		updateObjectives(175, "", 0);
	}
}

script 2 (void)
{
	int i;
	for(i = 0; i < 4; i++)
	{
		Thing_Spawn(9, spamBots1[i],0, 255);
		Thing_Spawn(10, spamBots2[i],0, 255);
		delay(20*35);
	}
	Thing_Spawn(13, 201,0, 255);
	delay(10*35);
	ACS_Execute(3, 0, 0, 0, 0);
}

script 3 (void)
{
	while(thingcount(0, 255) > 0)
		delay(1);
	setmusic("D_HOME");
	printbold(s:"the assualt has ended!");
	delay(10*35);
	ACS_Execute(250, 0, 9, 0, 0);
}

script 4 (void)
{
	while(1)
	{
		if(CheckInventory("SpecialItem2"))
		{
				mapvar2 = 0;
				Door_Open(1, 16);
				printbold(s:"<AgentSpork> I recomend saving for this match!");
				delay(1);
				TakeInventory("SpecialItem2", 1);
				TakeInventory("SpecialItem3", 1);
		}
		delay(1);
	}
}

script 5 (void)
{
	if(mapvar2 == 0)
	{
		mapvar2 = 1;
		int rndX = 0;
		int rndY = 0;
		mapvar1 = 0;
		int rndAngle = 0;
		int rndCount = 0;
		int monster = 0;
		setmusic("");
		printbold(s:"Get ready to rumble!!!!!!!!!!!!!!!!!!111111111111111");
		if(CheckInventory("Health") <= 101)
		{
			Thing_Spawn(1, T_SOULSPHERE,0, 120);
		}
		if(CheckInventory("Cell") <= 230)
		{
			Thing_Spawn(2, T_BATTERY,0, 120);
		}
		if(CheckInventory("Armor") <= 50)
		{
			Thing_Spawn(3, T_GREENARMOR,0, 120);
		}
		if(CheckInventory("Shell") <= 40)
		{
			Thing_Spawn(14, T_SHELLS,0, 120);
		}
		Door_Close(1, 16);
		delay(5*35);
		setmusic("D_ATTACK");
		delay(1*35);
		while(mapvar1 != 10)
		{
			for(rndCount = 1; rndCount < random(5, 10); rndCount++)
			{
				monster = random(0, 5);
				rndX = random(Arena_Max_X, Arena_Min_X);
				rndY = random(Arena_Max_Y, Arena_Min_Y);
				rndAngle = random(0, 360);
				Spawn(arena[monster], rndX * FRACUNITS, rndY * FRACUNITS, 0, 99, rndAngle);
				Spawn("TeleportFog", rndX * FRACUNITS, rndY * FRACUNITS, 0, 0, 0);
				delay(15);
			}
			delay(random(5, 15)*35);
			mapvar1++;
		}
		ACS_Execute(7, 0, 0, 0, 0);
	}
}

script 6 (void)
{
	if(CheckInventory("SpecialItem3"))
	{
		Door_Close(1, 128);
		delay(1);
	}
}

script 7 (void)
{
	while(thingcount(0, 99) > 0)
		delay(1);
	setmusic("D_HOME");
	ACS_Execute(400,0,99,0,0);
	ACS_Execute(400,0,120,0,0);
	printbold(s:"Congrats!");
	questVar++;
	Door_Open(1, 16);
	GiveInventory("SpecialItem3", 1);
}

//give weapons back
script LVLLOAD (void)
{
	int i;
	if(weaponNum == 0)
	{
		weaponNum = 47;
		GiveInventory("Cell", 80);
		GiveInventory("Shell", 60);
		GiveInventory("Coin", 500);
	}
	while(i != 10)
	{
		if(findWeapon(weaponNum, Iweapons[i]))
		{
			GiveInventory(Xweapons[i], 1);
		}
		i++;
		delay(1);
	}
	
}

script LVLMAIN OPEN
{
	int i;
	SetMusic("D_OHOH");
	ChangeCamera(15, 1, 1);
	DoStory(177, 2, 1);
	scriptwait(501);
	SetMusic("D_HOME");
	ACS_Execute(253, 0, 0, 0, 0);
	updateObjectives(176, "O_4", 1);
	while(1)
	{
		if(questVar == 1)
		{
			GiveInventory("QuestItem31", 1);
			ACS_Terminate(255, 0);
		} delay(1);
	}
}