//**************************************************************************
//**
//** kaiser_21-map18.acs : poedDoom
//**$Revise Date: 12/31/05
//**$Author: kaiser
//**$Description: level script
//**
//**************************************************************************
#library "sc_m18"
#include "cif3_main.c"

#define HUDBACK 1000000

int mapvar1;
int bleh1[20] = {16, 8, 32, 32, 4, 3, 8, 4, 16, 16, 8, 16, 1, 8, 8, 32, 16, 8, 8, 1};
str bleh2[20] = {"MedKit15", "MedKit25", "HealthBonus", "ArmorBonus", "I_Armor1", "I_Armor2",
"ReflectTrophy", "I_Furry", "I_Grenade", "I_Grenade2", "I_GasCan", "I_MeatAmmo", "AmmoRefill",
"NewCell", "NewClip", "NewRocketBox", "NewShell", "NewCellPack", "NewClip2", "BlurSphere"};
str bleh3[9] = {"Claw", "Torque", "Buttman", "Cyclops", "Arnie", "Bow", "Ralph", "NewbMelee",
 "NewbMeleeStrong"};
 str bleh4[9] = {"NewCell", "NewClip", "NewRocketBox", "NewShell", "NewCellPack", "NewClip2", "I_Grenade2", "NewRocketBox",
 "NewRocketBox"};

int shavSubValue = 0;

int MIN_X = -7360 * FRACUNITS;
int MAX_Y = 7552 * FRACUNITS;
int MAX_X = 7744 * FRACUNITS;
int MIN_Y = -7552 * FRACUNITS;

script 1 (void)
{
	while(1)
	{
		if(CheckInventory("SpecialItem"))
		{
			ACS_Execute(2, 0, 0, 0, 0);
		}
		delay(1);
	}
}

script 2 (void)
{
	updateObjectives(38, "", 1);
	Thing_Activate(2);
	ThrustThing(0, 64, 0, 2);
	ACS_Terminate(1, 0);
}

script 3 (void)
{
	SetMusic("I_TOM10");
	Teleport(1);
	Thing_Spawn(4, 215, 192, 1000);
	shavSubValue = GetActorProperty(1000, APROP_Health) / 100;
	ACS_Execute(4, 0, 0, 0, 0);
}

script 4 (void)
{
	int colors;
	int i = 0, k = 0;
	ACS_Execute(8, 0, 0, 0, 0);
	ACS_Execute(11, 0, 0, 0, 0);
	//randomly spawn items
	for(i = 0; i < 20; i++)
	{
		for(k = 0; k < bleh1[i]; k++)
		{
			Spawn(bleh2[i], random(MIN_X, MAX_X), random(MIN_Y, MAX_Y), 1024*FRACUNITS, 0, 0);
		}
	}
	for(i = 0; i < 24; i++)
	{
		Spawn(bleh3[random(0, 8)], random(MIN_X, MAX_X), random(MIN_Y, MAX_Y), 1024*FRACUNITS, 1100+i, 0);
		Spawn("TeleportFog", getActorX(1100+i), getActorY(1100+i), getActorZ(1100+i), 0, 0);
		if(random(0, 21) & 1 == 1)
		{
			Thing_Hate (1100+i, 1000, 6);
		}
	}
	ACS_Execute(5, 0, 0, 0, 0);
	while(1)
	{
		if(GetActorProperty(1000, APROP_Health) <= 0)
		{
			DamageThing(0);
			SetHudSize(320, 200, 0);
			SetFont("CONFONT");
			hudmessage(s:"YOU FAIL IT! YOUR SKILL IS NOT ENOUGH!\nTRY AGAIN >:(";
			HUDMSG_PLAIN, HUDBACK-36, CR_RED, 160.0, 128.0, 0.1);
		}
		SetFont("CONFONT");
		SetHudSize(640, 480, 0);
		if(GetActorProperty(1000, APROP_Health) / shavSubValue < 40)
		colors = 6;
		else colors = 5;
		hudmessage(s:"Shaviro: ", i: GetActorProperty(1000, APROP_Health) / shavSubValue, s:"%"; HUDMSG_PLAIN, HUDBACK - 15, colors, 512.0, 32.0, 0.1);
		delay(1);
	}
}

script 5 (void)
{
	int i = 0;
	while((getActorY(1000) / FRACUNITS) > 2222)
		delay(1);
	for(i = 0; i < 24; i++)
	{
		Spawn(bleh3[random(0, 8)], random(-7300, -2400)*FRACUNITS,
		random(5000, -1200)*FRACUNITS, 1024*FRACUNITS, 1200+i, 0);
		Spawn("TeleportFog", getActorX(1200+i), getActorY(1200+i), getActorZ(1200+i), 0, 0);
		if(random(0, 21) & 1 == 1)
		{
			Thing_Hate (1200+i, 1000, 6);
		}
	}
	ACS_Execute(6, 0, 0, 0, 0);
}

script 6 (void)
{
	int i = 0;
	while((getActorX(1000) / FRACUNITS) < -1024)
		delay(1);
	for(i = 0; i < 64; i++)
	{
		Spawn(bleh3[random(0, 8)], random(-4096, 6000)*FRACUNITS,
		random(2048, -1900)*FRACUNITS, 1024*FRACUNITS, 1300+i, 0);
		Spawn("TeleportFog", getActorX(1300+i), getActorY(1300+i), getActorZ(1300+i), 0, 0);
		if(random(0, 21) & 1 == 1)
		{
			Thing_Hate (1300+i, 1000, 6);
		}
	}
	for(i = 0; i < 16; i++)
	{
		Spawn(bleh4[random(0, 8)], random(-4096, 6000)*FRACUNITS, random(2048, -1900)*FRACUNITS, 1024*FRACUNITS, 0, 0);
	}
	ACS_Execute(7, 0, 0, 0, 0);
}

script 7 (void)
{
	int i = 0;
	while((getActorY(1000) / FRACUNITS) > -5888)
		delay(1);
	for(i = 0; i < 64; i++)
	{
		Spawn(bleh3[random(0, 8)], random(-1680, 6500)*FRACUNITS,
		random(-6512, -3840)*FRACUNITS, 1024*FRACUNITS, 1400+i, 0);
		Spawn("TeleportFog", getActorX(1400+i), getActorY(1400+i), getActorZ(1400+i), 0, 0);
		if(random(0, 21) & 1 == 1)
		{
			Thing_Hate (1400+i, 1000, 6);
		}
	}
	for(i = 0; i < 24; i++)
	{
		Spawn(bleh4[random(0, 8)], random(-1680, 6500)*FRACUNITS, random(-6512, -3840)*FRACUNITS, 1024*FRACUNITS, 0, 0);
	}
}

script 8 (void)
{
	while(1)
	{
		if(random(0, 80) == 0)
		{
			Thing_Activate(6);
		}
		delay(1);
	}
}

script 9 (void)
{
	if((thingcount(0, 7) <= 0) && mapvar1 == 0)
	{
		mapvar1++;
	}
}

script 10 (void)
{
	if(mapvar1 == 1)
	{
		if((getActorY(1000) / FRACUNITS) < -7568)
		{
			mapvar1++;
			teleport_nofog(9);
			thing_deactivate(1000);
		}
	}
	else if(mapvar1 == 4)
	{
		mapvar1 = -1;
		teleport_nofog(13);
		thing_deactivate(1000);
	}
}

script 11 (void)
{
	while(mapvar1 < 2)
		delay(1);
	if(mapvar1 == 2)
	{
		mapvar1++;
		teleport_nofog(12);
		doStory(39, 2, 15);
		delay(2);
		ChangeCamera(8, 1, 1);
		scriptwait(501);
		ChangeCamera(8, 1, 1);
		delay(1*35);
		Thing_Activate(11);
		delay(1*35);
		Thing_Activate(11);
		delay(1*35);
		Thing_Activate(11);
		delay(1*35);
		Door_Open(5, 16);
		tagwait(5);
		doStory(41, 2, 1);
		scriptwait(501);
		thing_activate(1000);
		thing_activate(10);
	}
	ACS_Execute(14, 0, 0, 0, 0);
}

script 12 (int tag)
{
	Ceiling_RaiseByValue(tag, 32, 120);
	tagwait(tag);
	delay(110);
	Ceiling_LowerByValue(tag, 32, 120);
}

script 13 (void)
{
	if(mapvar1 == 3)
	{
		mapvar1++;
	}
}

script 14 (void)
{
	while(mapvar1 != -1)
		delay(1);
	teleport_nofog(14);
	doStory(43, 2, 1);
	delay(2);
	ChangeCamera(15, 1, 1);
	scriptwait(501);
	ACS_Terminate(4, 0);
	SetActorProperty(1000, APROP_Speed, 0);
	Thing_Activate(1000);
	
}

script 15 (void)
{
	while((plyrZ / FRACUNITS) > -30000)
		delay(1);
	ACS_Execute(200, 0, 33, 0, 0);
}

//give weapons back
script 253 (void)
{
	int i;
	if(weaponNum == 0)
	{
		weaponNum = 255;
		GiveInventory("Cell", 240);
		GiveInventory("ClipBox", 120);
		GiveInventory("RocketAmmo", 50);
		GiveInventory("Shell", 40);
		GiveInventory("CleaverSpecial", 1);
		GiveInventory("PanSpecial", 1);
		GiveInventory("ShockSpecial", 1);
		GiveInventory("JetPack", 1);
		GiveInventory("Coin", 500);
	}
	while(i != 10)
	{
		if(findWeapon(weaponNum, Iweapons[i]))
		{
			GiveInventory(Xweapons[i], 1);
		}
		i++;
		delay(1);
	}
	
}

script 255 OPEN
{
	ACS_Execute(15, 0, 0, 0, 0);
	Sector_SetFloorScale (1, 6, 6, 6, 6);
	Sector_SetCeilingPanning (3, 32, 0, 0, 0);
	Sector_SetFloorPanning (4, 32, 0, 0, 0);
	if(weaponNum == 0)
	ACS_Execute(253, 0, 0, 0, 0);
	doStory(35, 3, 1*35);
}