//**************************************************************************
//**
//** kaiser_21-map27.acs : poedDoom
//**$Revise Date: 11/05/06
//**$Author: kaiser
//**$Description: level script
//**
//**************************************************************************
#library "sc_m27"
#include "cif3_main.c"

int pStch[8] = { 12, 13, 14, 15, 16, 17, 18, 9999 };
int pBit;
str t[3] = { "CAMTEX01", "CAMTEX02", "CAMTEX03" };

script 1 (void) {
	printbold(s:"Water Gate has been lowered..");
	ResetLinedef(1);
	delay(2*35);
	updateObjectives(230, "O_25", 1);
}

script 2 (int secBit) {
	int i;
	int bit;

	for(i = 0; i < 8; i++) {
		if(secBit & 1)
			pBit = pBit ^ (1 << i);
		secBit = (secBit >> 1);
	}

	bit = pBit;

	for(i = 0; i < 8; i++) {
		if(!(bit & 1)) {
			Floor_LowerToLowest(pStch[i], 80);
			tagwait(pStch[i]);
		}
		else if(bit & 1) {
			Floor_RaiseToLowestCeiling(pStch[i], 80);
			tagwait(pStch[i]);
		}

		bit = (bit >> 1);
	}
}

script 3 (void) {
	Radius_Quake (6, 2*35, 0, 64, 19);
	delay(15);
	Thing_SpawnNoFog(20, 185, 0, 21);
	Floor_LowerToLowestTxTy(29, 255);
	delay(20);
	Thing_SpawnNoFog(22, 204, 0, 0);
	delay(5);
	Thing_Remove(21);
}

script 4 (void) {
	int destx = 3632 * FRACUNITS;
	int desty = -1984 * FRACUNITS;
	int srcx = 2224 * FRACUNITS;
	int srcy = 768 * FRACUNITS;
	int a;

	SetLineBlocking(2, BLOCK_EVERYTHING);
	delay(2*35);
	Floor_RaiseByValue(42, 8, 584);

	while(1) {
		if((plyrZ / FRACUNITS) >= 0) {
			a = GetActorAngle(0);
			Spawn("MapSpotNoClip", destx - (srcx - plyrX),
				desty - (srcy - plyrY), plyrZ + 1*FRACUNITS, 70, a);
			Radius_Quake (6, 1*35, 0, 64, 21);
			Radius_Quake (6, 1*35, 0, 64, 0);
			Teleport_NoFog(70);
			Radius_Quake (6, 1*35, 0, 64, 21);
			break;
		}
		delay(1);
	}
}

//give weapons back
script 253 (void) {
	int i;
	if(weaponNum == 0) {
		weaponNum = 1023;
		GiveInventory("Cell", 280);
		GiveInventory("ClipBox", 250);
		GiveInventory("RocketAmmo", 130);
		GiveInventory("Shell", 100);
		GiveInventory("CleaverSpecial", 1);
		GiveInventory("PanSpecial", 1);
		GiveInventory("ShockSpecial", 1);
		GiveInventory("FlameSpecial", 1);
		GiveInventory("Coin", 4000);
		GiveInventory("JetPack", 1);
	}

	while(i != 10) {
		if(findWeapon(weaponNum, Iweapons[i])) {
			GiveInventory(Xweapons[i], 1);
		}
		i++;
		delay(1);
	}
	
}

script 255 OPEN
{
	int i;
	ACS_Execute(253, 0, 0, 0, 0);

	pBit = 41;

	for(i = 3; i < 6; i++)
		SetCameraToTexture(i, t[i-3], 90);

	delay(1);
	updateObjectives(229, "O_24", 1);
}