//**************************************************************************
//**
//** ai.acs : poedDoom
//**$Revise Date: 11/15/06
//**$Author: kaiser
//**$Description: scripted enemy behavior
//**
//**************************************************************************
//special ai code for enemies - Samuel Villarreal 9/2005
#library "ai_base"
#include "zcommon.acs"
#import "globals.c"
#import "indexes.c"
#import "gamfuncs.c"

bool isFiring = false;
bool allyIsFiring = false;

script 902 (void)
{
	A_LeapAttack();
}

script 667 (void)
{
	A_WheelChase();
}

script 668 (void)
{
	A_DrillPain();
	delay(1);
	checkForBleeding = false;
}

script 663 (void)
{
	A_SetupAdmin();
}

script 664 (void)
{
	A_AdminThinker();
}

script 666 (void)
{
	A_SplitBlob();
}

script 662 (void)
{
	A_PlayHarp();
}

script 661 (void)
{
	A_NewbGib();
}

script 660 (void)
{
	A_ClawFly();
}

script 558 (void) {
	A_PDemon_LeakBite();
}

script 559 (void)
{
	A_PDemon_CheckDistance();
}

script 560 (void)
{
	A_TossSomething("MaxPieces", 816);
	if(thingcount(0, 816) >= 64) {
		Thing_Remove(816);
	}
}

script 561 (void) {
	A_SpreadShot("SpreadMissile", true, 8, 32);
}

script 562 (void) {
	SpawnMobjMissile("NewbNaplam", "weapons/rocket2", true, 0, 64, 24, 48);
}

script 563 (void) {
	int ticker;
	int x = getActorX(0);
	int y = getActorY(0);
	int z = getActorZ(0);
	while(ticker != 16) {
		Spawn("WmullBoom", x + (random(-256, 256) << 16), y + (random(-256, 256) << 16),
		z + (random(0, 128) << 16), 0, 0);

		ticker++;
		delay(1);
	}
}

script 564 (void) {
	A_SpreadShot("SpreadMissile", true, 32, 48);
}

script 565 (void) {
	A_BillShout();
}

script 566 (void) {
	A_AllyCheck();
}

script 567 (void) {
	A_Strafe(_T(_I()), 0, 0, random(0, 1), 4, 0, random(48, 96));
}

script 568 (void) {
	A_Strafe(_T(_I()), 0, 0, random(0, 1), 4, 0, random(96, 127));
}

script 569 (void) {
	A_Evade();
}

script 570 (void) {
	isFiring = true;
}

script 571 (void) {
	isFiring = false;
}

script 574 (void) {
	allyIsFiring = true;
}

script 575 (void) {
	allyIsFiring = false;
}

//left
script 572 (void) {
	int mobjID;
	if(CheckInventory("QuestItem3")) {
		mobjID = A_CheckAllyTarget(0, 40, 40);
		A_FaceTarget(0, mobjID);
		A_Strafe(0, mobjID, true, true, 4, 0, 8);
		A_FaceTarget(0, mobjID);
	}
	else {
		A_FaceTarget(0, 0);
		A_Strafe(0, 0, true, true, 4, 0, 8);
		A_FaceTarget(0, 0);
	}
}

//right
script 573 (void) {
	int mobjID;
	if(CheckInventory("QuestItem3")) {
		mobjID = A_CheckAllyTarget(0, 40, 40);
		A_FaceTarget(0, mobjID);
		A_Strafe(0, mobjID, true, false, 4, 0, 8);
		A_FaceTarget(0, mobjID);
	}
	else {
		A_FaceTarget(0, 0);
		A_Strafe(0, 0, true, false, 4, 0, 8);
		A_FaceTarget(0, 0);
	}
}

script 576 (void) {
	A_TossSomething("NewbGunFly", 0);
	A_TossSomething("NewbGunFly", 0);
	delay(20);
	if(random(0, 4) == 0)
		A_TossSomething("NewbGibLeg", 0);
}

function void A_LeapAttack (void)
{
	if(GetActorZ(0) == GetActorFloorZ(0))
	ThrustThingZ(0, 32, 0, 0);
}

function void A_WheelChase (void)
{
	if(GetActorZ(0) == GetActorFloorZ(0))
	{
		ThrustThing((GetActorAngle(0) >> 8), 8);
		TakeInventory("QuestItem14", 1);
	}
	else if(GetActorZ(0) > GetActorFloorZ(0) && checkInventory("QuestItem14") == 0
	&& GetActorZ(0) < plyrZ)
	{
		ThrustThing((GetActorAngle(0) >> 8), 8);
		ThrustThingZ(0, (((GetActorZ(0) - GetActorFloorZ(0)) >> 16) - 128), 0, 0);
		GiveInventory("QuestItem14", 1);
	}
}

function void A_DrillPain (void)
{
	if(A_ReachPlayerLen(getActorX(0), getActorY(0)) < 128)
	checkForBleeding = true;
}

function void A_SetupAdmin(void)
{
	/*if(!CheckInventory("Coin"))
	{
		GiveInventory("Coin", (GetActorZ(0) - GetActorFloorZ(0)) / FRACUNITS);
	}*/
}

function void A_AdminThinker(void)
{
	int distance = A_ReachPlayerLen(getActorX(0), getActorY(0));

	ThrustThingZ(0, 1, 0, 0);
	if ((GetActorCeilingZ(0) - (32 << 16) > GetActorZ(0)) || distance < 104)
		GiveInventory("AdminThinker", 1);
}

function void A_SplitBlob(void) {
	int i;
	for(i = 0; i < 2; i++) {
		Spawn("SplitBlob", GetActorX(0) + random(-80, 80) * FRACUNITS,
		GetActorY(0) + random(-80, 80) * FRACUNITS, GetActorZ(0), 166, random(0, FRACUNITS));
		if(thingcount(0, 166) > 0) {	
			Thing_ChangeTID (166, 0);
		}
	}
}

function void A_PlayHarp(void) {
	if((timer() % 3 == 0)) {
		ActivatorSound("other/harp", 32);
	}
}

function void A_ClawFly(void) {
	if((random(0, 128) & 7) == 0 || (getActorZ(0) == getActorFloorZ(0))) {
		ThrustThingZ(0, 16, 0, 0);
	}
	if((random(0, 128) & 7) == 7) {
		ThrustThingZ(0, -16, 0, 0);
	}
}

function void A_PDemon_CheckDistance(void) {
	int distance;
	distance = AproxDistance (PlyrX - GetActorX(0), PlyrY - GetActorY(0));
	distance = distance / FRACUNITS;
	if(!(distance > 50)) {
		GiveInventory("QuestItem31", 1);
	}
}

function void A_PDemon_LeakBite(void) {
	int distance;
	distance = AproxDistance (PlyrX - GetActorX(0), PlyrY - GetActorY(0));
	distance = distance / FRACUNITS;
	if(!(distance > 50)) {
		bitByPdemon = true;
	}
}

function void A_NewbGib(void)
{
	A_TossSomething("NewbGibEye", 0);
	A_TossSomething("NewbGibArm", 0);
	A_TossSomething("NewbGibHead", 0);
	A_TossSomething("NewbGibLeg", 0);
	A_TossSomething("NewbGibLeg", 0);
}

function bool A_IsNearAllies(int maxSearch, int distance, int tid) {
	int dist, i;

	for(i = 0; i < GetStack(); i++) {
		if(_Type(i) == FRIEND) {
			dist = A_GetDistance(GetActorX(tid), _X(i), GetActorY(tid), _Y(i));
			if(dist <= distance) {
				return true;
			}
		}
	}
	return false;
}

function void A_SpreadShot(str type, bool quake, int fixZ, int radius) {
	int i;
	int distance;
	int slope;
	int tid = GetAvailableSysTid();
	if(quake)
		Radius_Quake (6, 1*35, 0, 64, 0);
	for(i = 65; i < 115; i++) {
		A_SpawnInFront(GetActorX(0), GetActorY(0), GetActorZ(0) + (fixZ<<16),
		type, GetActorAngle(0), tid, radius);
		ThrustThing(((GetActorAngle(tid) >> 8) + 90) - i, 64, 1, tid);
		distance = AproxDistance (PlyrX - GetActorX(0), PlyrY - GetActorY(0));
		distance = distance / 32;
		if (distance < 1)
		distance = 1;
		if(PlyrZ - GetActorZ(0) < 64) {
			slope = 0;
		}
		else {
			slope = 4;
		}
		ThrustThingZ(tid, (((PlyrZ >> 16) - (GetActorZ(0) >> 16))
		/ (distance >> 16) * 9) + slope, 0, 0);
		Thing_ChangeTID (tid, 0);
	}
}

function void A_BillShout(void) {
	int distance = A_ReachPlayerLen(GetActorX(0), GetActorY(0));
	int sndDistance = distance >> 4;

	if(sndDistance > 127)
		sndDistance = 127;

	AmbientSound("monsters/billbillbill", 127 - sndDistance);
}

function void A_FaceTarget(int actor, int tid) {
	int x, y, z, angle;

	if(!tid) {
		x = plyrX;
		y = plyrY;
		z = plyrZ;
		angle = plyrAngle;
	}
	else {
		x = getActorX(tid);
		y = getActorY(tid);
		z = getActorZ(tid);
		angle = getActorAngle(tid);
	}

	SetActorAngle(actor, VectorAngle(x - GetActorX(actor), y - GetActorY(actor)));
}

function int A_GetDistance(int x1, int x2, int y1, int y2) {
	int distance;
	distance = AproxDistance (x2 - x1, y2 - y1);
	distance = distance >> 16;

	return distance;
}

function int A_GetDistanceZ(int z1, int z2) {
	z1 >>= 16;
	z2 >>= 16;

	return abs(z2 - z1);
}

function int A_GetFOVRange(int x1, int y1, int x2, int y2, int a) {
	return abs((VectorAngle(x1 - x2, y1 - y2) - a) >> 8);
}

function bool A_CheckFOV(int x1, int y1, int x2, int y2, int a, int fov) {
	int result = A_GetFOVRange(x1, y1, x2, y2, a);
	static int range[2];

	range[0] = 128 + fov;
	range[1] = 128 - fov;

	if(result <= range[0] && result >= range[1])
		return true;

	return false;
}

function void A_AllyCheck(void) {
	int x, y, dist, zdist;

	x = _X(_I());
	y = _Y(_I());

	dist = A_GetDistance(x, y, plyrX, plyrY);
	zdist = A_GetDistanceZ(GetActorZ(0), plyrZ);

	if(A_CheckFOV(x, y, plyrX, plyrY, _Angle(_I()), 24)
		&& /*(dist <= 512 &&*/ zdist <= 128/*)*/) {
		GiveInventory("QuestItem1", 1);
		if(!random(0, 2)) {
			A_Strafe(_T(_I()), 0, true, random(0, 1), 4, 0, 72);
		}
		return;
	}
	else {
		TakeInventory("QuestItem1", 1);
	}

	x = _X(_I());
	y = _Y(_I());

	for(int i = 0; i < GetStack(); i++) {
		if(_Type(i) == FRIEND) {

			dist = A_GetDistance(x, y, _X(i), _Y(i));

			if(A_CheckFOV(x, y, _X(i), _Y(i), _Angle(_I()), 8) 
				&& dist <= 512) {
				GiveInventory("QuestItem1", 1);
				if(!random(0, 1)) {
					A_Strafe(_T(_I()), _T(i), true, random(0, 1), 4, 0, 72);
				}
				return;
			}
			else {
				TakeInventory("QuestItem1", 1);
			}
		}
	}
}

function void A_Strafe(int t, int t2, bool target, bool dir,
					   int thrust, int thrustz, int thDir) {
	int angle;
	int dirMove;

	if(dir)
		dirMove = thDir;
	else
		dirMove = -thDir;

	if(target)
		A_FaceTarget(t, t2);

	angle = GetActorAngle(t) >> 8;

	ThrustThing(angle + dirMove, thrust, 0, t);
	ThrustThingZ(t, thrustz, 0, 0);
}

function bool A_CheckPlayerTarget(int tid, int fov1, int fov2) {
	static int vec[6];

	vec[0] = GetActorX(tid);
	vec[1] = GetActorY(tid);
	vec[2] = GetActorAngle(tid);

	vec[3] = plyrX;
	vec[4] = plyrY;
	vec[5] = plyrAngle;

	if(A_CheckFOV(vec[0], vec[1], vec[3], vec[4], vec[2], fov1)
		&& A_CheckFOV(vec[3], vec[4], vec[0], vec[1], vec[5], fov2))
		return true;

	return false;
}

function int A_CheckAllyTarget(int tid, int fov1, int fov2) {
	static int vec[6];

	vec[0] = GetActorX(tid);
	vec[1] = GetActorY(tid);
	vec[2] = GetActorAngle(tid);

	for(int i = 0; i < GetStack(); i++) {

		if(_Type(i) == FRIEND) {

			vec[3] = _X(i);
			vec[4] = _Y(i);
			vec[5] = _Angle(i);

			if(A_CheckFOV(vec[0], vec[1], vec[3], vec[4], vec[2], fov1)
				&& A_CheckFOV(vec[3], vec[4], vec[0], vec[1], vec[5], fov2))
				return _T(i);
		}
	}

	return -1;
}

function bool A_DoEvadePlayer(int t) {
	static bool d = false;
	int result;
	
	if(A_CheckPlayerTarget(t, 40, 32)) {
		result = A_GetFOVRange(plyrX, plyrY, GetActorX(t), GetActorY(t), plyrAngle);

		if(result >= 128) {
			GiveInventory("QuestItem2", 1);
			TakeInventory("QuestItem3", 1);
			d = false;
		}
		else if(result < 128) {
			GiveInventory("QuestItem1", 1);
			TakeInventory("QuestItem3", 1);
			d = true;
		}

		A_Strafe(t, 0, true, d,
			(GetActorProperty(0, APROP_Speed) >> 16),
			((GetActorProperty(0, APROP_Speed) >> 16) / 4) + 16, random(56, 72));

		return true;
	}

	return false;
}

function bool A_DoEvadeAlly(int t) {
	static bool d = false;
	int result, mobj;

	mobj = A_CheckAllyTarget(t, 40, 40);
	
	TakeInventory("QuestItem3", 1);
	if(mobj > 0) {
		result = A_GetFOVRange(GetActorX(mobj), GetActorY(mobj),
			GetActorX(t), GetActorY(t), GetActorAngle(mobj));

		if(result >= 128) {
			GiveInventory("QuestItem2", 1);
			GiveInventory("QuestItem3", 1);
			d = false;
		}
		else if(result < 128) {
			GiveInventory("QuestItem1", 1);
			GiveInventory("QuestItem3", 1);
			d = true;
		}

		A_Strafe(t, mobj, true, d, (GetActorProperty(0, APROP_Speed) >> 16),
			((GetActorProperty(0, APROP_Speed) >> 16) / 4) + 16, random(56, 72));

		return true;
	}

	return false;
}

function void A_Evade(void) {
	if(GetActorZ(0) == GetActorFloorZ(0)) {
		if(allyIsFiring == true) {
			if(A_DoEvadeAlly(0) == true)
				return;
		}
		if(isFiring == true) {
			if(A_DoEvadePlayer(0) == true)
				return;
		}
	}
}