//**************************************************************************
//**
//** ai_dron.acs : poedDoom
//**$Revise Date: 3/04/06
//**$Author: kaiser
//**$Description: 'dron' boss behavior
//**
//**************************************************************************
//Ai code for boss 'dron'		-Samuel Villarreal 9/2005

int xBit[8] = {0, 384, 0, -384, 320, 320, -320, -320};
int yBit[8] = {384, 0, -384, 0, 320, -320, -320, 320};
str dronHelpers[10] = {"NewbMeleeFast", "NewbMelee", "NewbMeleeFast", "NewbMeleeStrong", "NewbMissle3",
"NewbMeleeFast", "NewbMissle2", "NewbMissle4", "NewbMissle2", "NewbMissle6"};
bool stopMe = false;
int bossValue = 0;
bool bossGauge = false;
int musicCheck = 0;
int playerX, playerY, playerZ;
bool isFar = false;
int bleh = 0;
bool canEvade = false;
bool misc = false;
bool misc2 = false;

script 903 (void)
{
	TakeInventory("QuestItem22", 1);
	canEvade = false;
	SetActorProperty(masterTid, APROP_Speed, 384*35000);
	if(GetActorZ(masterTid) == GetActorFloorZ(masterTid))
	{
		ThrustThing((GetActorAngle(0) / 256), 16);
		ThrustThingZ(masterTid, 64 + ((getDistanceX() + getDistanceY()) / 64), 0, 1);
	}
	stopMe = true;
}

script 904 (void)
{
	if(canEvade == true && CheckInventory("QuestItem22") == 0)
	{
		GiveInventory("QuestItem22", 1);
	}
	bossGauge = true;
	musicCheck++;
	if(isFar && CheckInventory("QuestItem20") == 0)
	GiveInventory("QuestItem20", 1);
	if(CheckInventory("QuestItem21"))
	TakeInventory("QuestItem21", 1);
	SetActorProperty(masterTid, APROP_Speed, 60*35000);
	if(GetActorProperty(masterTid, APROP_Health) < 5500 && misc == false)
	{
		GiveInventory("QuestItem19", 1);
		misc = true;
	}
	misc2 = false;
	if(stopMe == true)
	{
		SetLineMonsterBlocking(2, 1);
		delay(1*35);
		stopMe = false;
		SetLineMonsterBlocking(2, 0);
	}
}

//attack#3
script 905 (void)
{
	int x = GetActorX(masterTid);
	int y = GetActorY(masterTid);
	int a = GetActorAngle(masterTid);
	int i;
	ACS_Execute(907, 0, 0, 0, 0);
	TakeInventory("QuestItem22", 1);
	canEvade = false;
	for(i = 0; i < 8; i++)
	{
		Spawn("TeleportFog", (x + (xBit[i] * FRACUNITS)), (y + (yBit[i] * FRACUNITS)), 0, 0, a);
		Spawn(dronHelpers[random(0, 9)], (x + (xBit[i] * FRACUNITS)), (y + (yBit[i] * FRACUNITS)), 0,
		150 + i, a / 256);
	}
}

script 906 ENTER
{
	int colors;
	while(1)
	{
		if(musicCheck == 1)
		{
			tagDron(40);
			SetMusic("D_BOSS1");
			musicCheck++;
		}
		if(bossGauge == true)
		{
			SetFont("CONFONT");
			SetHudSize(640, 480, 0);
			if(GetActorProperty(masterTid, APROP_Health) / bossSubValue < 40)
			colors = 6;
			else colors = 5;
			hudmessage(s:"Dron: ", i: GetActorProperty(masterTid, APROP_Health) / bossSubValue, s:"%"; HUDMSG_PLAIN, HUDBACK - 15, colors, 512.0, 32.0, 0.1);
		}
		delay(1);
	}
}

script 907 (void)
{
	while(thingcount(0, 150) > 0)
		delay(1);
	while(thingcount(0, 151) > 0)
		delay(1);
	while(thingcount(0, 152) > 0)
		delay(1);
	while(thingcount(0, 153) > 0)
		delay(1);
	while(thingcount(0, 154) > 0)
		delay(1);
	while(thingcount(0, 155) > 0)
		delay(1);
	while(thingcount(0, 156) > 0)
		delay(1);
	while(thingcount(0, 157) > 0)
		delay(1);
	GiveInventory("QuestItem25", 1);
}

script 908 (void)
{
	int i;
	int tempHealth = GetActorProperty(masterTid, APROP_Health);
	TakeInventory("QuestItem22", 1);
	canEvade = false;
	for(i = 0; i < 8; i++)
	{
		Spawn("Vaporize", GetActorX(150 + i), GetActorY(150 + i), 0, 0, 0);
		Thing_Remove(150 + i);
	}
		TakeInventory("QuestItem25", 1);
		SetActorProperty(masterTid, APROP_Health, tempHealth + 5000);
}

script 909 (void)
{
	int angle = GetActorAngle(masterTid) / 256;
	ThrustThing(angle - 64, 32);
	ThrustThingZ(0, 64, 0, 1);
}

//gather player's coord data every second
script 910 (void)
{
	//GiveInventory("QuestItem14", 1);
	while(1)
	{
		playerX = GetActorX(0);
		playerY = GetActorY(0);
		playerZ = GetActorZ(0);
		if(getDistanceX() > 3500 || getDistanceY() > 3500)
		{
			if(isFar == false && misc == false)
			{
				printbold(s:"<Dron> Hey you! Get back here!");
				isFar = true;
			}
		}

		if((getDistanceX() + getDistanceY()) < 4000 && (isFiring == true || allyIsFiring == true))
		{
			if(timer() & 32)
				canEvade = true;
				misc2 = true;
		}

		delay(1);
	}
}

script 911 (void)
{
	SetActorProperty(masterTid, APROP_Speed, 255*35000);
	if((getDistanceX() + getDistanceY()) < 2000)
		{
			if(CheckInventory("QuestItem20"))
			TakeInventory("QuestItem20", 1);
			isFar = false;
			stopMe = true;
			GiveInventory("QuestItem21", 1);
			TakeInventory("QuestItem22", 1);
		}
}

script 912 (void)
{
	if((getDistanceX() + getDistanceY()) < 4000 && canEvade == false && misc2 == false)
	{
		if(timer() & 32)
		canEvade = true;
		misc2 = true;
	}
}

script 913 (void)
{
	TakeInventory("QuestItem22", 1);
	canEvade = false;
	misc2 = false;
}

script 914 (void)
{
	int angle = GetActorAngle(masterTid) / 256;
	ThrustThing(angle + 64, 32);
	ThrustThingZ(0, 64, 0, 1);
}

script 915 (void)
{
	int minX = 3072;
	int maxX = 18432;
	int minY = -4608;
	int maxY = 10752;
	int i;
	SetPlayerProperty(0, 1, 0);
	for(i = 0; i < 8; i++)
	{
		Spawn("Vaporize", GetActorX(150 + i), GetActorY(150 + i), 0, 0, 0);
		Thing_Remove(150 + i);
	}
	printbold(s:"I see you are tougher than I though");
	delay(4*35);
	printbold(s:"Doesn't matter, the community is dead and there is nothing you can do about it");
	delay(4*35);
	printbold(s:"I must be going now, too bad I can't stay and play some more :(");
	delay(4*35);
	Spawn("TeleportFog", GetActorX(masterTid), GetActorY(masterTid), 0, 0, 0);
	Thing_Remove(masterTid);
	ACS_Terminate(910, 0);
	delay(4*35);
	printbold(s:"bhwhahahahahahaha");
	for(i = 0; i < 1024; i++)
	{
		Spawn("Explosion", random(minX, maxX)* FRACUNITS, random(minY, maxY)* FRACUNITS,
		random(0, 128)* FRACUNITS, 0, 0);
	}
	delay(5*35);
	SetPlayerProperty(0, 0, 0);
	bleh = 1;
}

script 916 (void)
{
	if(CheckInventory("QuestItem19"))
	Teleport(random(200, 249));
}

function int getDistanceX(void)
{
	int bX = GetActorX(masterTid);
	int result = (playerX - bX) / FRACUNITS;
	if(result < 0)
	result *= -1;
	return result;
}

function int getDistanceY(void)
{
	int bY = GetActorY(masterTid);
	int result = (playerY - bY) / FRACUNITS;
	if(result < 0)
	result *= -1;
	return result;
}

function void setupDronTeleporters(void)
{
	int minX = 4224;
	int maxX = 16448;
	int minY = -2048;
	int maxY = 9696;
	int i;
	for(i = 0; i < 50; i++)
	{
		Spawn("MapSpot", random(minX, maxX)* FRACUNITS, random(minY, maxY)* FRACUNITS, 0, 200 + i, 0);
	}
}

function void tagDron(int tid)
{
	masterTid = tid;
	bossSubValue = GetActorProperty(masterTid, APROP_Health) / 100;
	setupDronTeleporters();
}