//**************************************************************************
//**
//** ai_dron2.acs : poedDoom
//**$Revise Date: 7/28/06
//**$Author: kaiser
//**$Description: 'Dron' boss behavior
//**
//**************************************************************************

bool playerStomp = false;
//int isAttacking = 0;
bool slappedByDron = false;
int oldx, oldy;

function void tagDron(int tid) {
	masterTid = tid;
	Thing_ChangeTID (0, tid);
}

//must call script 1 in map25 in order to effect the player
script 903 (void) {
	A_DronStomp();
}

//check if player is near Dron.. if so then jump away from the player
script 904 (void) {
	int dist;
	dist = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
	if((dist >> 16) < 384) {
		GiveInventory("QuestItem1", 1);
	}
	else {
		if(/*isAttacking*/isFiring == true || (allyIsFiring == true && !(timer() & 3))) {
			if(timer() & 1)
				GiveInventory("QuestItem3", 1);
			else GiveInventory("QuestItem4", 1);
		}
	}
	if((dist >> 16) > 2048) {
		GiveInventory("QuestItem24", 1);
	}
}

script 905 (void) {
	tagDron(750);
	friendSpecial = true;
}

script 906 (void) {
	if(drawHealth == false) {
		bossSubValue = GetActorProperty(masterTid, APROP_Health) / 100;
		delay(1);
		SetMusic("D_DRON");
		drawHealth = true;
	}
}

script 907 ENTER {
	int colors;
	while(1) {
		if(drawHealth == true) {
			SetFont("CONFONT");
			SetHudSize(640, 480, 0);
			if(GetActorProperty(masterTid, APROP_Health) / bossSubValue < 40)
				colors = 6;
			else colors = 5;
			hudmessage(s:"Dron: ", i: GetActorProperty(masterTid, APROP_Health) / bossSubValue, s:"%"; HUDMSG_PLAIN, HUDBACK - 37, colors, 512.0, 32.0, 0.1);
		}
		delay(1);
	}
}

script 908 (void) {
	A_DronEvadeAway();
}

script 909 (void) {
	A_Dron2SpreadShot();
}

script 910 (void) {
	ThrustThing((GetActorAngle(0) / 256), 160);
	if(GetActorZ(0) < 8) {
		ThrustThingZ(0, 80, 0, 0);
		Spawn("Dron2_Seeker_Boom", getActorX(0), getActorY(0), getActorZ(0),
			0, getActorAngle(0) / 256);
		Spawn("Dron2_Seeker_Crackle", getActorX(0), getActorY(0), getActorZ(0),
				0, getActorAngle(0) / 256);
	}
}

script 911 (void) {
	A_SuperSeekerSpawn();
	GiveInventory("QuestItem2", 1);
}

script 912 (void) {
	if(!(thingCount(0, 6500)&&
		thingCount(0, 6501)&&
		thingCount(0, 6502)&&
		thingCount(0, 6503)&&
		thingCount(0, 6504)&&
		thingCount(0, 6505)&&
		thingCount(0, 6506)&&
		thingCount(0, 6507))) {
		TakeInventory("QuestItem2", 1);
		ACS_Terminate(910, 0);
	}
}

script 913 (void) {
	int ticker = 0;
	int i;
	while(ticker++ != 512) {
		for(i = 0; i < 8; i++) {
			if(!(timer() & 7)) {
				Spawn("Dron2_Charge_Sparkle", getActorX(300+i), getActorY(300+i), getActorZ(300+i),
				0, getActorAngle(300+i) / 256);
			}
		}
		delay(1);
	}
}

script 914 (void) {
	A_SuperCharge();
}

script 915 (void) {
	//isAttacking = isAttacking ^ 1;
}

script 916 (void) {
	ThrustThing((GetActorAngle(MasterTid) / 256) + 64, 128);
	ThrustThingZ(0, 32, 0, 0);
	//isAttacking = 0;
}

script 917 (void) {
	ThrustThing((GetActorAngle(MasterTid) / 256) - 64, 128);
	ThrustThingZ(0, 32, 0, 0);
	//isAttacking = 0;
}

script 918 (void) {
	int dist, dist2, i;
	dist = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
	ThrustThing((GetActorAngle(MasterTid) / 256), 64);
	ThrustThingZ(0, 1, 0, 0);
	if(oldx == GetActorX(masterTid) && oldy == GetActorY(masterTid)) {
		if(getActorZ(masterTid) == 0) {
			printbold(s:"<Dron> Get out of my way you n00bs!");
			ThrustThingZ(0, 80, 0, 0);
		}
	}
	for(i = 8000; i < 8300; i++) {	//now this is really pushing it..
		dist2 = AproxDistance (GetActorX(i) - GetActorX(masterTid),
			GetActorY(i) - GetActorY(masterTid));
		if((dist2 / 65536) <= 512) {
			ThrustThing(random(0, 360), 96, 0, i);
			ThrustThingZ(i, 64, 0, 0);
			Thing_Damage(i, 256);
		}
	}
	oldx = GetActorX(masterTid);
	oldy = GetActorY(masterTid);
	if((dist / 65536) < 512) {
		GiveInventory("QuestItem5", 1);
	}
}

script 919 (void) {
	int dist;
	dist = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
	if((dist / 65536) < 512) {
		slappedByDron = true;
	}
}

script 920 (void) {
	SetMusic("");
	printbold(s:"<Dron> HOW CAN THIS BE?!?!?!?!?!? NOOOOOOOOOOOOOO!!!!");
}

script 921 (void)
{
	int ticker;
	while(ticker != 128)
	{
		if((random(0, 256) & 7) != 0)
		Spawn("TripBoom", getActorX(masterTid) + random(-256, 256) * FRACUNITS,
		getActorY(masterTid) + random(-256, 256) * FRACUNITS, getActorZ(masterTid) + random(0, 128) * FRACUNITS,
		0, getActorAngle(masterTid) / 256);
		ticker++;
		delay(1);
	}
}

script 922 (void) {
	Radius_Quake (5, 5*35, 0, 64, masterTid);
	Spawn("DeadDron", getActorX(masterTid), getActorY(masterTid), getActorZ(masterTid),
		0, getActorAngle(masterTid) / 256);
	Spawn("TeleportFog", getActorX(masterTid), getActorY(masterTid), getActorZ(masterTid),
		0, getActorAngle(masterTid) / 256);
	delay(4*35);
	ACS_Execute(3, 0, 0, 0, 0);
}

script 923 (void) {
	int dist;
	dist = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
	ThrustThing((GetActorAngle(MasterTid) / 256), 32);
	ThrustThingZ(0, 72, 0, 0);
	if((dist / 65536) < 512) {
		GiveInventory("QuestItem5", 1);
	}
}

function void A_DronStomp(void) {
	int i;
	if(plyrZ == GetActorZ(masterTid)) {
		playerStomp = true;
		Radius_Quake (5, 1*35, 0, 64, masterTid);
	}
	for(i = 8000; i < 8500; i++) {
		ThrustThingZ(i, 64, 0, 0);
		Thing_Damage(i, 128);
	}
}

function void A_DronEvadeAway(void) {
	ThrustThing((GetActorAngle(MasterTid) / 256) - 128, 128);
	ThrustThingZ(0, 32, 0, 0);
}

function void A_Dron2SpreadShot (void) {
	int i;
	int distance;
	int slope;
	int angle;
	Radius_Quake (5, 1*35, 0, 64, masterTid);
	for(i = 0; i < 32; i++) {
		A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid) + 8*FRACUNITS,
		"DronBall", angle, 3000+i, 64);
		ThrustThing((GetActorAngle(3000+i) / 256), 64, 1, 3000+i);
		angle += 8*256;
		distance = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
		distance = distance / 32;
		if (distance < 1)
		distance = 1;
		if(PlyrZ - GetActorZ(masterTid) < 64) {
			slope = 0;
		}
		else {
			slope = 4;
		}
		ThrustThingZ(3000+i, (((PlyrZ / FRACUNITS) - (GetActorZ(masterTid) >> 16))
		/ (distance >> 16) * 9) + slope, 0, 0);
		Thing_ChangeTID (3000+i, 0);
	}
}

function void A_SuperSeekerSpawn(void) {
	int i;
	int angle = GetActorAngle(masterTid);
	for(i = 0; i < 8; i++) {
		A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid) + 48*FRACUNITS,
		"Dron2_Seeker", angle, 6500+i, 64);
		angle += random(5, 12) * 256;
	}
}

function void A_SuperCharge(void) {
	int i;
	int angle = GetActorAngle(masterTid);
	for(i = 0; i < 8; i++) {
		A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid),
		"Dron2_Charge_Ground", angle, 0, 64);
		A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid) + 128*FRACUNITS,
		"Dron2_Charge_Top", angle, 300+i, 64);
		angle += random(0, 128) * 256;
	}
	ACS_Execute(913, 0, 0, 0, 0);
}
