//**************************************************************************
//**
//** ai_edward.acs : poedDoom
//**$Revise Date: 8/01/06
//**$Author: kaiser
//**$Description: 'Edward' boss behavior
//**
//**************************************************************************

bool edwardActivate = false;
int shootLooper = 0;
bool slappedByEdward = false;

/*There are some cases where replacing / 256 with >> 8 will not work at all.. what gives*/

function void tagEdward(int tid) {
	masterTid = tid;
	Thing_ChangeTID (0, tid);
}

script 410 (void) {
	ACS_Terminate(907, 0);
	tagEdward(810);
	edwardActivate = true;
	drawHealth = false;
	friendSpecial = true;
}

script 411 (void) {
	if(drawHealth == false) {
		bossSubValue = GetActorProperty(masterTid, APROP_Health) / 100;
		delay(1);
		SetMusic("D_EDBOSS");
		drawHealth = true;
	}
}

script 412 ENTER {
	int colors;
	while(1) {
		if(drawHealth == true && edwardActivate == true) {
			SetFont("CONFONT");
			SetHudSize(640, 480, 0);
			if(GetActorProperty(masterTid, APROP_Health) / bossSubValue < 40)
				colors = 6;
			else colors = 5;
			hudmessage(s:"Edward: ", i: GetActorProperty(masterTid, APROP_Health) / bossSubValue, s:"%"; HUDMSG_PLAIN, HUDBACK - 37, colors, 512.0, 32.0, 0.1);
		}
		delay(1);
	}
}

//looper
script 413 (void) {
	shootLooper = 0;
	while(1) {
		A_EdwardLooper_1();
		delay(1);
	}
}

script 414 (void) {
	shootLooper++;
	if(shootLooper == 16) {
		TakeInventory("QuestItem1", 1);
		TakeInventory("QuestItem3", 1);
		shootLooper = 0;
		//isAttacking = 0;
	}
}

script 415 (void) {
	ThrustThing((GetActorAngle(MasterTid) >> 8) + 64, 2048);
	//isAttacking = 0;
}

script 416 (void) {
	ThrustThing((GetActorAngle(MasterTid) >> 8) - 64, 2048);
	//isAttacking = 0;
}

script 417 (void) {
	int dist, dist2, i;
	dist = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
	if((dist / 65536) < 320) {
		slappedByEdward = true;
	}

	for(i = 8000; i < 8300; i++) {	//now this is really pushing it..
		dist2 = AproxDistance (GetActorX(i) - GetActorX(masterTid),
		GetActorY(i) - GetActorY(masterTid));
		if((dist2 >> 16) <= 320) {
			ThrustThing(random(0, 360), 96, 0, i);
			ThrustThingZ(i, 64, 0, 0);
			Thing_Damage(i, 256);
		}
	}
	//isAttacking = 0;
}

script 418 (void) {
	ACS_Execute(419, 0, 0, 0, 0);
}

script 419 (void) {
	while(1) {
		Spawn("Edward_JetFire", getActorX(masterTid), getActorY(masterTid),
			getActorZ(masterTid) - 32*FRACUNITS, 0, 0);
		delay(1);
	}
}

script 420 (void) {
	A_EdwardLooper_2();
}

script 421 (void) {
	if(GetActorZ(masterTid) == 0) {
		Radius_Quake (5, 1*35, 0, 64, masterTid);
		GiveInventory("QuestItem5", 1);
	}
}

script 422 (void) {
	int i;
	int minX = 1536;
	int maxX = 29184;
	int minY = -9216;
	int maxY = 18432;
	SetMusic("");
	ACS_Terminate(413, 0);
	printbold(s:"<Edward> This is impossible!!!");
	delay(4*35);
	printbold(s:"<Edward> You may win but rest assured your community will die!");
	delay(4*35);
	printbold(s:"If we don't destroy your community, someone else will!");
	delay(100);
	printbold(s:"Mark my words, someone... else.... will!!");
	delay(8*35);
	doStory(268, 1, 1);scriptwait(501);
	delay(4*35);
	for(i = 0; i < 1024; i++) {
		Spawn("Explosion", random(minX, maxX)* FRACUNITS, random(minY, maxY)* FRACUNITS,
		random(0, 128)* FRACUNITS, 0, 0);
	}
	delay(5*35);
	ACS_Execute(250, 0, 26, 0, 0);
}

script 423 (void) {
	int ticker;
	while(ticker != 128) {
		if((random(0, 256) & 7) != 0)
		Spawn("TripBoom", getActorX(masterTid) + random(-256, 256) * FRACUNITS,
		getActorY(masterTid) + random(-256, 256) * FRACUNITS, getActorZ(masterTid) + random(0, 128) * FRACUNITS,
		0, getActorAngle(masterTid) / 256);
		ticker++;
		delay(1);
	}
}

script 424 (void) {
	Radius_Quake (5, 5*35, 0, 64, masterTid);
	Spawn("DeadEdward", getActorX(masterTid), getActorY(masterTid), getActorZ(masterTid),
		0, getActorAngle(masterTid) / 256);
	Spawn("TeleportFog", getActorX(masterTid), getActorY(masterTid), getActorZ(masterTid),
		0, getActorAngle(masterTid) / 256);
}

function void A_EdwardLooper_1 (void) {
	int dist;
	dist = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
	ThrustThing((GetActorAngle(MasterTid) >> 8), 6);
	ThrustThingZ(0, 1, 0, 0);

	if(((dist >> 16) > 512) && isFiring == true/*isAttacking*/) {
		GiveInventory("QuestItem2", 1);
	}

	if((dist >> 16) < 512) {
		GiveInventory("QuestItem1", 1);
	}

	if(oldx == GetActorX(masterTid) && oldy == GetActorY(masterTid)) {
		if(getActorZ(masterTid) == 0) {
			if(A_IsNearAllies(8300, 320, masterTid)) {
				GiveInventory("QuestItem3", 1);
			}
			else { ThrustThingZ(0, 112, 0, 0); }
		}
	}

	oldx = GetActorX(masterTid);
	oldy = GetActorY(masterTid);
	SetActorPosition(masterTid, GetActorX(masterTid), GetActorY(masterTid), 0, false);
}

function void A_EdwardLooper_2 (void) {
	int dist;
	dist = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
	ThrustThing((GetActorAngle(MasterTid) >> 8), 2);

	if((dist >> 16) < 512) {
		GiveInventory("QuestItem4", 1);
		ACS_Terminate(419, 0);
	}
}
