//**************************************************************************
//**
//** ai_gnewt.acs : poedDoom
//**$Revise Date: 12/4/05
//**$Author: kaiser
//**$Description: 'Gnewt' boss behavior
//**
//**************************************************************************

script 903 (void)
{
	if((GetActorFloorZ(0) >> 16) == 0 && GetActorZ(masterTid) == GetActorFloorZ(masterTid))
	{
		//Spawn("MapSpot", PlyrX, PlyrY, 0, 100, PlyrAngle);
		A_SpawnInFront(PlyrX, PlyrY, 0, "MapSpot", GetActorAngle(masterTid), 100, 24);
		GiveInventory("QuestItem1", 1);
	}
}

script 904 (void)
{
	int ticker = 150;
	int i;
	while(ticker != 0)
	{
		if((random(0, 256) & 7) != 0)
		{
			for(i = 0; i < 16; i++)
			{
				Spawn("Smoke2", getActorX(masterTid) + random(-256, 256) << 16,
				getActorY(masterTid) + random(-256, 256) << 16, getActorZ(masterTid) + random(0, 128) << 16,
				0, getActorAngle(masterTid) >> 8);
			}
		}
		ticker--;
		delay(1);
	}
}

script 905 (void)
{
	A_GnewtSpreadShot();
}

script 906 (void)
{
	tagGnewt(66);
	bossSubValue = GetActorProperty(masterTid, APROP_Health) / 100;
	delay(1);
	SetMusic("I_PROP");
	drawHealth = true;
}

script 907 ENTER
{
	int colors;
	if(GetLevelInfo(LEVELINFO_LEVELNUM) == 33)
		terminate;
	while(1)
	{
		if(drawHealth == true)
		{
			SetFont("CONFONT");
			SetHudSize(640, 480, 0);
			if(GetActorProperty(masterTid, APROP_Health) / bossSubValue < 40)
			colors = 6;
			else colors = 5;
			hudmessage(s:"Killingblair: ", i: GetActorProperty(masterTid, APROP_Health) / bossSubValue, s:"%"; HUDMSG_PLAIN, HUDBACK - 37, colors, 512.0, 32.0, 0.1);
		}
		delay(1);
	}
}

script 908 (void)
{
	int dist;
	dist = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
	ThrustThingZ(masterTid, 208, 0, 0);
	dist = dist >> 16;
	if(!(dist > 208))
	{
		hitByGnewt = true;
	}
}

script 909 (void)
{
	//Thing_Remove(100);
	if(GetActorFloorZ(masterTid) != 0)
	{
		ThrustThing(random(0, 360), 4);
	}
}

script 910 (void)
{
	A_TossGnewtGib("GnewtGut1");
	A_TossGnewtGib("GnewtGut2");
	A_TossGnewtGib("GnewtGut3");
	A_TossGnewtGib("GnewtGut4");
	A_TossGnewtGib("GnewtGut5");
	A_TossGnewtGib("GnewtGut6");
	delay(5*35);
	ACS_Execute(250, 0, 18, 0, 0);
}

script 911 (void)
{
	A_TossGnewtGib("GnewtGut1");
	A_TossGnewtGib("GnewtGut2");
	A_TossGnewtGib("GnewtGut3");
	A_TossGnewtGib("GnewtGut4");
	A_TossGnewtGib("GnewtGut5");
	A_TossGnewtGib("GnewtGut6");
}

script 912 (void)
{
	int ticker;
	while(ticker != 128)
	{
		if((random(0, 256) & 7) != 0)
		Spawn("WmullBoom", getActorX(masterTid) + random(-256, 256) << 16,
		getActorY(masterTid) + random(-256, 256) << 16, getActorZ(masterTid) + random(0, 128) << 16,
		0, getActorAngle(masterTid) >> 8);
		ticker++;
		delay(1);
	}

	A_TossGnewtGib("GnewtGut1");
	A_TossGnewtGib("GnewtGut2");
	A_TossGnewtGib("GnewtGut3");
	A_TossGnewtGib("GnewtGut4");
	A_TossGnewtGib("GnewtGut5");
	A_TossGnewtGib("GnewtGut6");
	delay(5*35);
	ACS_Execute(250, 0, 18, 0, 0);
}

function void A_TossGnewtGib(str type)
{
	Spawn(type, GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid) + 80<<16, 208,
	random(0, 360));
	ThrustThing(GetActorAngle(208) >> 8, random(8, 16), 0, 208);
	ThrustThingZ(208, random(48, 128), 0, 0);
	Thing_ChangeTID (208, 0);
}

function void A_GnewtSpreadShot(void)
{
	int i;
	int distance;
	int slope;
	for(i = 65; i < 115; i++)
	{
		A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid) + 48<<16,
		"GnewtProjectile2", GetActorAngle(masterTid), 67, 40);
		ThrustThing(((GetActorAngle(67) >> 8) + 90) - i, 64, 1, 67);
		distance = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
		distance = distance / 32;
		if (distance < 1)
		distance = 1;
		if(PlyrZ - GetActorZ(masterTid) < 64)
		{
			slope = 0;
		}
		else
		{
			slope = 4;
		}
		ThrustThingZ(67, (((PlyrZ >> 16) - (GetActorZ(masterTid) >> 16))
		/ (distance >> 16) * 9) + slope, 0, 0);
		Thing_ChangeTID (67, 0);
	}
}

function void tagGnewt(int tid)
{
	masterTid = tid;
	Thing_ChangeTID (0, tid);
}