//**************************************************************************
//**
//** ai_incubus.acs : poedDoom
//**$Revise Date: 6/09/06
//**$Author: kaiser
//**$Description: 'Incubus' boss behavior
//**
//**************************************************************************

function void tagIncubus(int tid) {
	masterTid = tid;
	Thing_ChangeTID (0, tid);
}

script 903 (void) {
	A_IncubusSpreadShot();
}

script 904 (void) {
	int ticker;
	while(ticker != 128) {
		if((random(0, 256) & 7) != 0)
		Spawn("TripBoom", getActorX(masterTid) + random(-256, 256) * FRACUNITS,
		getActorY(masterTid) + random(-256, 256) * FRACUNITS, getActorZ(masterTid) + random(0, 128) * FRACUNITS,
		0, getActorAngle(masterTid) / 256);
		ticker++;
		delay(1);
	}
}

script 905 (void) {
	tagIncubus(599);
}

script 906 (void) {
	if(drawHealth == false) {
		bossSubValue = GetActorProperty(masterTid, APROP_Health) / 100;
		delay(1);
		SetMusic("I_PROP");
		drawHealth = true;
	}
}

script 907 ENTER {
	int colors;
	while(1) {
		if(drawHealth == true) {
			SetFont("CONFONT");
			SetHudSize(640, 480, 0);
			if(GetActorProperty(masterTid, APROP_Health) / bossSubValue < 40)
				colors = 6;
			else colors = 5;
			hudmessage(s:"Belial: ", i: GetActorProperty(masterTid, APROP_Health) / bossSubValue, s:"%"; HUDMSG_PLAIN, HUDBACK - 37, colors, 512.0, 32.0, 0.1);
		}
		delay(1);
	}
}

script 908 (void) {
	int distance;
	ACS_ExecuteAlways(660, 0);
	distance = AproxDistance (PlyrX - GetActorX(0), PlyrY - GetActorY(0));
	distance = distance / FRACUNITS;
	if(!(distance > 420)) {
		bitByIncubus = true;
	}
}

function void A_IncubusSpreadShot(void) {
	int i;
	int distance;
	int slope;
	for(i = 65; i < 115; i++) {
		A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid),
		"IncubusMissile", GetActorAngle(masterTid), 67, 90);
		ThrustThing((GetActorAngle(67) / 256 + 90) - i, 64, 1, 67);
		distance = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
		distance = distance / 32;
		if (distance < 1)
		distance = 1;
		if(PlyrZ - GetActorZ(masterTid) < 64) {
			slope = 0;
		}
		else {
			slope = 4;
		}
		ThrustThingZ(67, (((PlyrZ / FRACUNITS) - (GetActorZ(masterTid) / FRACUNITS))
		/ (distance / FRACUNITS) * 9) + slope, 0, 0);
		Thing_ChangeTID (67, 0);
	}
}