//**************************************************************************
//**
//** ai_triphon.acs : poedDoom
//**$Revise Date: 4/22/06 -REJECTED #2
//**$Author: kaiser
//**$Description: 'Triphon' boss behavior
//**
//**************************************************************************

bool startCheck = false;
bool var0 = false;

int speed = 8;
int mode = 0;
int move = 0;
int think = 16;

#define MODE_SPIN	0
#define	MODE_THROW	1
#define MODE_POUND	2
#define MODE_IDLE	3
#define MODE_READY	4

int ball[2] = {0, 128*256};
int ballTurn[2] = {0, 0};
int ballX[2] = {0, 0};
int ballY[2] = {0, 0};
int ballZ[2] = {0, 0};
int ballHeight[2] = {64, 64};
int ballOffset[2] = {32, 32};

script 903 (void) {
	int dist;
	int i;
	friendSpecial = true;	//heh
	while(1) {
		dist = AproxDistance (PlyrX - GetActorX(4000), PlyrY - GetActorY(4000));
		if((dist / 65536) <= 96 && PlyrZ <= (GetActorZ(masterTid) + 32*FRACUNITS)) {
			ThrustThing(random(0, 360), 64, 0, 0);
			ThrustThingZ(0, 32, 0, 0);
			DamageThing(16);
		}
		dist = AproxDistance (PlyrX - GetActorX(4001), PlyrY - GetActorY(4001));
		if((dist / 65536) <= 96 && PlyrZ <= (GetActorZ(masterTid) + 32*FRACUNITS)) {
			ThrustThing(random(0, 360), 64, 0, 0);
			ThrustThingZ(0, 32, 0, 0);
			DamageThing(16);
		}
		//I'd doubt there will be over 500 friends in the level.. 9_9
		for(i = 8000; i < 8500; i++) {
			dist = AproxDistance (GetActorX(i) - GetActorX(4000),
				GetActorY(i) - GetActorY(4000));
			if((dist / 65536) <= 80) {
				ThrustThing(random(0, 360), 96, 0, i);
				ThrustThingZ(i, 64, 0, 0);
				Thing_Damage(i, 128);
			}
			dist = AproxDistance (GetActorX(i) - GetActorX(4001),
				GetActorY(i) - GetActorY(4001));
			if((dist / 65536) <= 80) {
				ThrustThing(random(0, 360), 96, 0, i);
				ThrustThingZ(i, 64, 0, 0);
				Thing_Damage(i, 128);
			}
		}
		delay(1);
	}
}

script 904 (void) {
	tagTriphon(1500);
	ACS_Execute(905, 0, 0, 0, 0);
}

script 905 (void) {
	int i;
	while(1) {
		A_DoBall(0);
		ballX[0] = GetActorX(4000); ballY[0] = GetActorY(4000);
		ballZ[0] = GetActorZ(4000);

		A_DoBall(1);
		ballX[1] = GetActorX(4001); ballY[0] = GetActorY(4001);
		ballZ[1] = GetActorZ(4001);

		updateBall();
		
		delay(1);
		Thing_Remove(4000);
		Thing_Remove(4001);
		for(i = 0; i < 6; i++) {
			Thing_Remove(4005 * 1 + i);
			Thing_Remove(4005 * 2 + i);
		}
	}
}

script 906 (void) {
	if(drawHealth == false) {
		bossSubValue = GetActorProperty(masterTid, APROP_Health) / 100;
		delay(1);
		SetMusic("I_PROP");
		drawHealth = true;
		startCheck = true;
	}
}

script 907 ENTER {
	int colors;
	while(1) {
		if(drawHealth == true) {
			SetFont("CONFONT");
			SetHudSize(640, 480, 0);
			if(GetActorProperty(masterTid, APROP_Health) / bossSubValue < 40)
			colors = 6;
			else colors = 5;
			if(GetActorProperty(masterTid, APROP_Health) / bossSubValue <= 50) {
				think = 24;
				speed = 16;
			}
			hudmessage(s:"Zap610: ", i: GetActorProperty(masterTid, APROP_Health) / bossSubValue, s:"%"; HUDMSG_PLAIN, HUDBACK - 37, colors, 512.0, 32.0, 0.1);
		}
		delay(1);
	}
}

script 908 (void) {
	if(CheckInventory("QuestItem1")) {
		mode = MODE_IDLE;
		ball[0] = GetActorAngle(masterTid) - 64*256;
		ball[1] = GetActorAngle(masterTid) + 64*256;
	}
	delay(1*35);
	if(!(random(0, 256) & think))
		mode = MODE_POUND;
	else
		mode = MODE_THROW;
	var0 = false;
	move = 0;
}

script 909 (void) {
	int ticker;
	mode = MODE_IDLE;
	ball[0] = GetActorAngle(masterTid) - 32*256;
	ball[1] = GetActorAngle(masterTid) + 32*256;
	ballHeight[0] = 128;
	ballHeight[1] = 128;
	while(ticker != 128) {
		if((random(0, 256) & 7) != 0)
		Spawn("TripBoom", getActorX(masterTid) + random(-256, 256) * FRACUNITS,
		getActorY(masterTid) + random(-256, 256) * FRACUNITS, getActorZ(masterTid) + random(0, 128) * FRACUNITS,
		0, getActorAngle(masterTid) / 256);
		ticker++;
		delay(1);
	}
}

script 910 (void) {
	int i;
	Thing_Remove(4000);
	Thing_Remove(4001);
	for(i = 0; i < 6; i++) {
		Thing_Remove(4005 * 1 + i);
		Thing_Remove(4005 * 2 + i);
	}
	for(i = 0; i < 2; i++) {
		A_TossSomething("TripBallParentDead", 0);
	}
	for(i = 0; i < 12; i++) {
		A_TossSomething("TripBallChildDead", 0);
	}
	SetMusic("");
	ACS_Terminate(903, 0);
	ACS_Terminate(905, 0);
	ACS_Terminate(907, 0);
	delay(2*35);
	Door_Open(3, 16);
}

function void tagTriphon(int tid) {
	masterTid = tid;
	Thing_ChangeTID (0, tid);
}

function void updateBall(void) {
	int i;
	if(mode == MODE_SPIN) {
		for(i = 0; i < 2; i++) {
			ballHeight[i] = 64;
			if(ballTurn[i] == 0) {
				ball[i] += speed*256;
				if(ball[i] >= 256*256) {
					ball[i] = 0;
				}
			}
			else {
				ball[i] -= speed*256;
				if(ball[i] <= 0) {
					ball[i] = 256*256;
				}
			}
		}
	}
	else if(mode == MODE_IDLE) {
		for(i = 0; i < 2; i++) {
			if(ballHeight[i] > ((GetActorZ(masterTid) / FRACUNITS) + 16))
			ballHeight[i]--;
		}
	}
	else if(mode == MODE_THROW) {
		ballHeight[0] = 32;
		ball[0] = GetActorAngle(masterTid);
		if(ballTurn[0] == 0 && var0 == false)
			ballOffset[0]+=12;
		else {
			var0 = true;
			ballOffset[0]-=12;
			if(ballOffset[0] <= 32) {
				mode = MODE_SPIN;
				ballOffset[0] = 32;
				TakeInventory("QuestItem1", 1);
				ball[0] = GetActorAngle(masterTid) - 64*256;
				ball[1] = GetActorAngle(masterTid) + 64*256;
			}
		}
	}
	else if(mode == MODE_POUND) {
		ball[0] = GetActorAngle(masterTid) - 32*256;
		ball[1] = GetActorAngle(masterTid) + 32*256;
		for(i = 0; i < 2; i++) {
			if(ballHeight[i] > 224 && ballTurn[i] == 0) {
				var0 = true;
				ballTurn[i] = ballTurn[i] ^ 1;
			}

			if(ballHeight[i] < 224 && ballTurn[i] == 1 && var0 == false) {
				mode = MODE_SPIN;
				ballOffset[i] = 32;
				TakeInventory("QuestItem1", 1);
				ball[0] = GetActorAngle(masterTid) - 64*256;
				ball[1] = GetActorAngle(masterTid) + 64*256;
				move = 0;
				ballHeight[i] = 64;
				return;
			}

			if(ballTurn[i] == 0)
				ballHeight[i]+=move++;
			else
				ballHeight[i]-=move++;

			if(ballTurn[i] == 1 && 
				ballHeight[i] <= 16) {
				A_Pound();
				ThingSound(masterTid, "monsters/newbhit", 127);
				mode = MODE_SPIN;
				ballOffset[i] = 32;
				TakeInventory("QuestItem1", 1);
				ball[0] = GetActorAngle(masterTid) - 64*256;
				ball[1] = GetActorAngle(masterTid) + 64*256;
				move = 0;
				ballHeight[i] = 64;
			}
		}
	}
	else if(mode == MODE_READY) {
		ball[0] = 96*256;
		ball[1] = 32*256;
		for(i = 0; i < 2; i++) {
			if(ballHeight[i] < 224 && var0 == false)
				ballHeight[i]+=move++;

			if(ballHeight[i] >= 224)
				var0 = true;

			if(var0 == true)
				ballHeight[i]-=move++;

			if(ballHeight[i] <= 16 && var0 == true) {
				ThingSound(masterTid, "monsters/newbhit", 127);
				var0 = false;
				move = 0;
				ballHeight[i] = 16;
			}
		}
	}
}

function void A_Pound(void) {
	int i;
	Radius_Quake (5, 1*35, 0, 64, masterTid);
	for(i = 0; i < 16; i++) {
		Spawn("TripPound", getActorX(masterTid) + random(-384, 384) * FRACUNITS,
		getActorY(masterTid) + random(-384, 384) * FRACUNITS,
		getActorZ(masterTid) + random(0, 256) * FRACUNITS,
		0, getActorAngle(masterTid) / 256);
	}
}

function void A_DoBall(int id) {
	int dist, spread, step, i, distZ, spreadZ, stepZ;
	A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid),
	GetActorZ(masterTid) + ballHeight[id]*FRACUNITS, "TripBallParent",
	ball[id], 4000 + id, ballOffset[id]);

	if(thingcount(0, 4000 + id)) {
		dist = AproxDistance (GetActorX(masterTid) - GetActorX(4000+id),
			GetActorY(masterTid) - GetActorY(4000+id));
		dist = dist / FRACUNITS;
		spread = dist / 26;

		distZ = (GetActorZ(4000+id) / FRACUNITS) - 
			((GetActorZ(masterTid) + 64*FRACUNITS) / FRACUNITS);
		spreadZ = distZ / 6;

		for(i = 0; i < 6; i++) {
			step += spread;
			stepZ += spreadZ;
			A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid),
			((GetActorZ(masterTid) + 64*FRACUNITS) + (stepZ * FRACUNITS)),
			"TripBallChild", ball[id], 4005 * (id+1) + i, step);
		}
	}

	if(thingcount(0, 4000 + id) == 0) {
		ballTurn[id] = ballTurn[id] ^ 1;
		ThingSound(masterTid, "weapons/powerhit", 127);
		//try spawning it again and move it back a bit
		A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid),
		GetActorZ(masterTid) + ballHeight[id]*FRACUNITS, "TripBallParent",
		ball[id], 4000 + id, ballOffset[2]);
		updateBall();
		Spawn("TripPuff", ballX[id], ballY[id], ballZ[id], 4003 + id, 0);
		ThrustThingZ(4003 + id, 40, 0, 0);
	}
}
