//**************************************************************************
//**
//** ai_wmull.acs : poedDoom
//**$Revise Date: 1/2/06 -REJECTED DAY
//**$Author: kaiser
//**$Description: 'Wmull' boss behavior
//**
//**************************************************************************

/*
	QuestItem1	-	EarthQuake attack	(Orb 1) Green
	QuestItem2	-	Charning attack		(Orb 2) Purple
	QuestItem3	-	Lightning attack	(Orb 3) Po'Ed Blue
	QuestItem4	-	FireTrail attack	(Orb 4) Red
*/

bool intStart = true;
#define DEFAULTOFFSET 32
#define DEFAULTSPEED 4
int offset = DEFAULTOFFSET;
int speed = DEFAULTSPEED;
int orb[4] = {0, 64*256, 128*256, 192*256};
int orbDefault[4] = {0, 64*256, 128*256, 192*256};
int randomFireDir[32] = {0, 0, 0, 0, 90, 90, 90, 90, 180, 180, 180, 180, 360, 360, 360, 360,
						0, 0, 0, 0, 90, 90, 90, 90, 180, 180, 180, 180, 360, 360, 360, 360};

script 903(void)
{
	ACS_Suspend(905, 0);
}

script 904 (void)
{
	tagWmull(1300);
	ACS_Execute(905, 0, 0, 0, 0);
}

//spinning orb functions
script 905 (void)
{
	int i;
	while(1)
	{
		A_DoOrb(orb[0], 2000, 2001, "WmullOrb", 80);
		A_DoOrb(orb[0], 2001, 2000, "WmullOrb", 80);
		A_DoOrb(orb[1], 2002, 2003, "WmullOrb2", 80);
		A_DoOrb(orb[1], 2003, 2002, "WmullOrb2", 80);
		A_DoOrb(orb[2], 2004, 2005, "WmullOrb3", 80);
		A_DoOrb(orb[2], 2005, 2004, "WmullOrb3", 80);
		A_DoOrb(orb[3], 2006, 2007, "WmullOrb4", 80);
		A_DoOrb(orb[3], 2007, 2006, "WmullOrb4", 80);
		for(i = 0; i < 4; i++)
		{
			orb[i] += speed*256;
			if(orb[i] >= 256*256)
			{
				orb[i] = 0;
			}
		}
		delay(1);
	}
}

script 906 (void)
{
	if(drawHealth == false)
	{
		bossSubValue = GetActorProperty(masterTid, APROP_Health) / 100;
		delay(1);
		SetMusic("D_WMULL");
		drawHealth = true;
	}
}

script 907 ENTER
{
	int colors;
	while(1)
	{
		if(drawHealth == true)
		{
			SetFont("CONFONT");
			SetHudSize(640, 480, 0);
			if(GetActorProperty(masterTid, APROP_Health) / bossSubValue < 40)
			colors = 6;
			else colors = 5;
			hudmessage(s:"Wmull: ", i: GetActorProperty(masterTid, APROP_Health) / bossSubValue, s:"%"; HUDMSG_PLAIN, HUDBACK - 37, colors, 512.0, 32.0, 0.1);
		}
		delay(1);
	}
}

script 908 (void)
{
	Spawn("WmullHead", GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid) + 80*FRACUNITS, 208,
	random(0, 360));
	ThrustThing(GetActorAngle(208) / 256, random(8, 16), 0, 208);
	ThrustThingZ(208, random(48, 128), 0, 0);
	Thing_ChangeTID (208, 0);
	SetMusic("");
	ACS_Terminate(905, 0);
	ACS_Terminate(907, 0);
	ACS_Terminate(903, 0);
	ACS_Terminate(914, 0);
}

script 909 (void)
{
	A_WmullSpreadShot();
}

script 910 (void)
{
	speed++;
}

script 911 (void)
{
	if(speed != 0)
	speed--;
}

script 912 (void)
{
	int i;
	speed = DEFAULTSPEED;
	offset = DEFAULTOFFSET;
	for(i = 0; i < 4; i++)
	{
		orb[i] = orbDefault[i];
	}
	
}

str orbType;
script 913 (void)
{
	int x, y, z, a, j, k;
	int i = A_ChooseOrb();
	if(i != -1)
	{
		x = getActorX(i); y = getActorY(i); z = getActorZ(i); a = getActorAngle(i);
		//reveal the orb, showing the player what orb type is about to rape him/her
		ACS_Suspend(905, 0);
		for(k = 2000; k < 2008; k++)
		{
			thing_Remove(k);
		}
		switch(i)
		{
			case 2001:
				Spawn("WmullOrb", x, y, z, i, 0);
				delay(35);
				thing_Remove(i);
				orbType = "WmullOrb";
				GiveInventory("QuestItem1", 1);
				ACS_Execute(914, 0, i, 0, 0);
			break;
			case 2003:
				Spawn("WmullOrb2", x, y, z, i, 0);
				delay(35);
				thing_Remove(i);
				orbType = "WmullOrb2";
				GiveInventory("QuestItem2", 1);
				ACS_Execute(914, 0, i, 0, 0);
			break;
			case 2005:
				Spawn("WmullOrb3", x, y, z, i, 0);
				delay(35);
				thing_Remove(i);
				orbType = "WmullOrb3";
				GiveInventory("QuestItem3", 1);
				ACS_Execute(914, 0, i, 0, 0);
			break;
			case 2007:
				Spawn("WmullOrb4", x, y, z, i, 0);
				delay(35);
				thing_Remove(i);
				orbType = "WmullOrb4";
				GiveInventory("QuestItem4", 1);
				ACS_Execute(914, 0, i, 0, 0);
			break;
		}
		delay(32*35);
		TakeInventory("QuestItem1", 1);
		TakeInventory("QuestItem2", 1);
		TakeInventory("QuestItem3", 1);
		TakeInventory("QuestItem4", 1);
		orbType = "";
		intStart = true;
		ACS_Execute(905, 0, 0, 0, 0);
	}
}

script 914 (int tid)
{
	while(1)
	{
		thing_Remove(tid);
		Spawn(orbType, getActorX(masterTid), getActorY(masterTid), 128*FRACUNITS, tid, 0);
		delay(1);
	}
}

script 915 (void)
{
	int i, angle;
	for(i = 0; i < 4; i++)
	{
		A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid),
		"WmullProjectile2Parent", GetActorAngle(masterTid) + angle, 4000, 48);
		angle += 64*256;
		ThrustThing(getActorAngle(4000) / 256, 64, 1, 4000);
		Thing_ChangeTID (4000, 0);
	}
	
}

script 916 (void)
{
	ThrustThing(randomFireDir[random(0, 31)], 32);
}

script 917 (void)
{
	int ticker;
	while(ticker != 128)
	{
		if((random(0, 256) & 7) != 0)
		Spawn("WmullBoom", getActorX(masterTid) + random(-256, 256) * FRACUNITS,
		getActorY(masterTid) + random(-256, 256) * FRACUNITS, getActorZ(masterTid) + random(0, 128) * FRACUNITS,
		0, getActorAngle(masterTid) / 256);
		ticker++;
		delay(1);
	}
}

function int A_ChooseOrb (void)
{
	int i;
	for(i = 2001; i < 2008; i+=2)
	{
		if((getActorAngle(masterTid) / 256 - getActorAngle(i) / 256) <= 32
		&& (getActorAngle(masterTid) / 256 - getActorAngle(i) / 256) >= -32)
		{
			return i;
		}
	}
	return -1;
}

function void A_WmullSpreadShot (void)
{
	int i;
	int distance;
	int slope;
	int angle;
	Radius_Quake (5, 1*35, 0, 64, masterTid);
	for(i = 0; i < 32; i++)
	{
		A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid) + 8*FRACUNITS,
		"WmullProjectile1", angle, 3000+i, 64);
		ThrustThing((GetActorAngle(3000+i) / 256), 64, 1, 3000+i);
		angle += 8*256;
		distance = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
		distance = distance / 32;
		if (distance < 1)
		distance = 1;
		if(PlyrZ - GetActorZ(masterTid) < 64)
		{
			slope = 0;
		}
		else
		{
			slope = 4;
		}
		ThrustThingZ(3000+i, (((PlyrZ / FRACUNITS) - (GetActorZ(masterTid) / FRACUNITS))
		/ (distance / FRACUNITS) * 9) + slope, 0, 0);
		Thing_ChangeTID (3000+i, 0);
	}
}

function void tagWmull(int tid)
{
	masterTid = tid;
	Thing_ChangeTID (0, tid);
}

function void A_DoOrb(int orbValue, int tid, int oldTid, str type, int height)
{
	if(intStart == true)
	{
		if(tid == 2007)
		{
			intStart = false;
		}
		A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid) + height*FRACUNITS,
		"TeleportFog", orbValue, 0, offset);
	}
	Thing_Remove(oldTid);
	A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid) + height*FRACUNITS,
	type, orbValue, tid, offset);
}