//**************************************************************************
//**
//** ai_xtron.acs : poedDoom
//**$Revise Date: 01/01/08
//**$Author: kaiser
//**$Description: 'XTron (Hobbs form 2)' boss behavior
//**
//**************************************************************************

int XTronArmTID[2];
bool ArmDetach = false;
bool XTronDeath = false;

script 410 (void)
{
	bossSubValue = GetActorProperty(masterTid, APROP_Health) / 100;
	delay(1);
	SetMusic("I_FBOSS");
	drawHealth = true;
}

script 411 (void)
{
	//int colors;
	XTron_Init();
	/*while(1)
	{
		if(drawHealth == true)
		{
			SetFont("CONFONT");
			SetHudSize(640, 480, 0);
			if(GetActorProperty(masterTid, APROP_Health) / bossSubValue < 40)
			colors = 6;
			else colors = 5;
			hudmessage(s:"Hobbs: ", i: GetActorProperty(masterTid, APROP_Health) / bossSubValue, s:"%"; HUDMSG_PLAIN,
				(HUDBACK+100) - 37, colors, 512.0, 32.0, 0.1);
		}
		delay(1);
	}*/
}

script 412 (void)
{
	XTron_ArmStick(ActivatorTid());
}

script 413 (void)
{
	int a = 1.0;
	int i;
	SetActorProperty(0,APROP_RenderStyle,64);
	for(i = 0; i < 10; i++)
	{
		SetActorProperty(0,APROP_Alpha, a);
		a -= 0.1;
		delay(1);
	} 
	SetActorProperty(0,APROP_Alpha, 0);
	Thing_Remove(0);
}

script 414 (void)
{
	int angle;
	int r;
	int dist;

	dist = AproxDistance (PlyrX - GetActorX(masterTid), PlyrY - GetActorY(masterTid));
	if((dist >> 16) < 1024)
		r = random(64, 128);
	else r = random(8, 48);

	if(checkInventory("QuestItem4"))
		angle = (GetActorAngle(masterTid) >> 8) + r;
	else if(checkInventory("QuestItem3"))
		angle = (GetActorAngle(masterTid) >> 8) - r;

	Spawn("XTron_Shadow", getActorX(masterTid), getActorY(masterTid), getActorZ(masterTid), 
		0, GetActorAngle(masterTid)>>8);
	ThrustThing(angle, 128, 1);
}

script 415 (void)
{
	if(isFiring == true || allyIsFiring == true && 
		(!(checkInventory("QuestItem3")||checkInventory("QuestItem4"))))
		if(timer() & 1) GiveInventory("QuestItem3", 1);
		else GiveInventory("QuestItem4", 1);

	if(ThingCount(0, XTronArmTID[0])<=0)
		A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid)+(256<<16),
			"XTron_Arm", GetActorAngle(masterTid) + (64<<8), XTronArmTID[0], 128);

	if(ThingCount(0, XTronArmTID[1])<=0)
		A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid)+(256<<16),
			"XTron_Arm", GetActorAngle(masterTid) - (64<<8), XTronArmTID[1], 128);
}

script 416 (void)
{
	int angle;
	int t = XTronArmTID[0];

	angle = (GetActorAngle(masterTid) >> 8) + random(-32, 32);
	Spawn("XTron_ArmShadow", getActorX(t), getActorY(t), getActorZ(t), 0, GetActorAngle(t)>>8);

	ThrustThing(angle, 64, 1);
}

script 417 (void)
{
	ArmDetach = true;
}

script 418 (void)
{
	if(ArmDetach == false)
	{
		TakeInventory("QuestItem25", 1);
		if(ThingCount(0, XTronArmTID[0])>0)
		{
			Thing_Remove(XTronArmTID[0]);
			delay(1);
			A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid)+(256<<16),
				"XTron_Arm", GetActorAngle(masterTid) + (64<<8), XTronArmTID[0], 128);
		}
		else
			A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid)+(256<<16),
				"XTron_Arm", GetActorAngle(masterTid) + (64<<8), XTronArmTID[0], 128);
	
		if(ThingCount(0, XTronArmTID[1])>0)
		{
			Thing_Remove(XTronArmTID[1]);
			delay(1);
			A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid)+(256<<16),
				"XTron_Arm", GetActorAngle(masterTid) - (64<<8), XTronArmTID[1], 128);
		}
		else
			A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid)+(256<<16),
				"XTron_Arm", GetActorAngle(masterTid) - (64<<8), XTronArmTID[1], 128);
	}
}

script 419 (void)
{
	ArmDetach = false;
	ACS_Terminate(420, 0);
}

script 420 (void)
{
	int limit = 0;
	while(1)
	{
		if(limit > 20 || !(ThingCount(0, XTronArmTID[0])))
		{
			ACS_ExecuteAlways(419, 0);
			break;
		}
		if(GetActorZ(XTronArmTID[0]) == GetActorFloorZ(XTronArmTID[0]) && limit <= 20)
		{
			A_XTronArmStomp();
			ThrustThingZ(XTronArmTID[0], 128, 0, 0);
			A_FaceTarget(XTronArmTID[0], 0);
			limit++;
		}
		ThrustThing(GetActorAngle(XTronArmTID[0])>>8, 1, 1);
		delay(1);
	}
}

script 421 (void)
{
	SetActorAngle(XTronArmTID[1], random(-128, 128)<<8);
	SpawnMobjMissile("XTron_Projectile2", "weapons/rocket2", false, 0, 256, 64, 150);
	SetActorProperty(XTronArmTID[1], APROP_Speed, 80<<16);
}

script 422 (void)
{
	int i;

	Thing_Remove(XTronArmTID[0]);
	Thing_Remove(XTronArmTID[1]);

	SetMusic("");

	while(1)
	{
		Radius_Quake (5, 1*35, 0, 64, masterTid);

		if(timer() & 1)
			Spawn("XTronBoom", getActorX(masterTid) + (random(-256, 256) << 16),
			getActorY(masterTid) + (random(-256, 256) << 16), getActorZ(masterTid) + (random(0, 1024) << 16), 0, 0);
		delay(1);
	}
}

script 423 (void)
{
	XTronDeath = true;
}

function void A_XTronArmStomp (void)
{
	int i;
	int angle;
	Radius_Quake (5, 1*35, 0, 64, XTronArmTID[0]);
	for(i = 0; i < 64; i++)
	{
		A_SpawnInFront(GetActorX(XTronArmTID[0]), GetActorY(XTronArmTID[0]), GetActorZ(XTronArmTID[0]) + (8<<16),
		"WmullProjectile1", angle, 3000+i, 64);
		ThrustThing((GetActorAngle(3000+i) >> 8), 64, 1, 3000+i);
		angle += (4<<8);
		Thing_ChangeTID (3000+i, 0);
	}
}

function void XTron_Init(void)
{
	XTronArmTID[0] = GetAvailableSysTid();
	XTronArmTID[1] = XTronArmTID[0]+1;
	masterTid = 0;
	bossSubValue = 0;
	drawHealth = false;
	tagXTron(_T(_I()));
	A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid)+(256<<16),
		"XTron_Arm", GetActorAngle(masterTid) + (64<<8), XTronArmTID[0], 128);

	A_SpawnInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid)+(256<<16),
		"XTron_Arm", GetActorAngle(masterTid) - (64<<8), XTronArmTID[1], 128);

	SetActorAngle(XTronArmTID[0], GetActorAngle(masterTid));
	SetActorAngle(XTronArmTID[1], GetActorAngle(masterTid));
	
}

function void XTron_ArmStick(int tid)
{
	int angle;
	int t;

	if(ArmDetach == true)
	{
		if(tid == XTronArmTID[0])
			GiveInventory("QuestItem22", 1);
		else if(tid == XTronArmTID[1])
			GiveInventory("QuestItem23", 1);
		return;
	}
	else
	{
		if(tid == XTronArmTID[0])
			TakeInventory("QuestItem22", 1);
		else if(tid == XTronArmTID[1])
			TakeInventory("QuestItem23", 1);
	}

	if(tid == XTronArmTID[0])
	{
		angle = GetActorAngle(masterTid)+(64<<8);
		t = XTronArmTID[0];
	}
	else if(tid == XTronArmTID[1])
	{
		angle = GetActorAngle(masterTid)-(64<<8);
		t = XTronArmTID[1];
	}
	A_SetInFront(GetActorX(masterTid), GetActorY(masterTid), GetActorZ(masterTid)+(256<<16),
		angle, t, 128);

	SetActorAngle(t, GetActorAngle(masterTid));
}

function void tagXTron(int tid)
{
	masterTid = tid;
	Thing_ChangeTID (0, tid);
}