#library "bndaries"
#import "globals.c"
#import "gamfuncs.c"
#include "zcommon.acs"
#include "BoundMap00.c"
#include "BoundMap01.c"
#include "BoundMap02.c"
#include "BoundMap03.c"
#include "BoundMap04.c"
#include "BoundMap05.c"
#include "BoundMap06.c"
#include "BoundMap07.c"
#include "BoundMap08.c"
#include "BoundMap09.c"
#include "BoundMap10.c"
#include "BoundMap11.c"
#include "BoundMap12.c"
#include "BoundMap13.c"
#include "BoundMap14.c"
#include "BoundMap15.c"
#include "BoundMap16.c"
#include "BoundMap17.c"
#include "BoundMap18.c"
#include "BoundMap19.c"
#include "BoundMap20.c"
#include "BoundMap21.c"
#include "BoundMap22.c"
#include "BoundMap23.c"
#include "BoundMap24.c"
#include "BoundMap25.c"
#include "BoundMap26.c"
#include "BoundMap27.c"
#include "BoundMap28.c"

#define BND_LINEID		0
#define BND_V1X			1
#define BND_V2X			2
#define BND_V1Y			3
#define BND_V2Y			4
#define BND_BOUNDMAX	1024
#define BND_MAX			4096

int hitmap[BND_MAX][BND_BOUNDMAX][2];
int chkPoints[BND_MAX];

#define BND_ANG_ANGLE	0
#define BND_ANG_MIDX	1
#define BND_ANG_MIDY	2

int lineAngles[BND_MAX][3];
int curBndMap = 0;

script BOUNDLOAD (int map) {
	int x1, x2, y1, y2;
	int i;
	int slopex, slopey;

	curBndMap = map;

	for(int lines = 0; lines < BND_MAX; lines++) {

		if(GetBoundProperty(lines, BND_LINEID, map) == 0)
			break;

		x1					= 0;
		x2					= 0;
		y1					= 0;
		y2					= 0;
		slopex				= 0;
		slopey				= 0;
		chkPoints[lines]	= 0;

		x1 = GetBoundProperty(lines, BND_V1X, map);
		x2 = GetBoundProperty(lines, BND_V2X, map);

		y1 = GetBoundProperty(lines, BND_V1Y, map);
		y2 = GetBoundProperty(lines, BND_V2Y, map);

		chkPoints[lines] = AproxDistance(x1 - x2, y1 - y2);
		chkPoints[lines] /= 32;

		if(chkPoints[lines]) {
			slopey = (y2 - y1) / chkPoints[lines];
			slopex = (x2 - x1) / chkPoints[lines];
			hitmap[lines][i][0] = x1 << 16;
			hitmap[lines][i][1] = y1 << 16;
		}
		else chkPoints[lines] = -1;

		CreateLineAngle(x1, x2, y1, y2, lines);

		for(i = 0; i < chkPoints[lines]; i++) {
			x1 += slopex;
			y1 += slopey;
			hitmap[lines][i][0] = x1 << 16;
			hitmap[lines][i][1] = y1 << 16;
		}

		if(i && i % 2 == 0)
			delay(1);
	}
	//printbold(s:"Loaded ", i: lines, s:" Boundaries");
}

function void CreateLineAngle(int x1, int x2, int y1, int y2, int line) {
	int angle;
	int x, y;

	x = x2 + x1;
	y = y2 + y1;

	x /= 2;
	y /= 2;

	lineAngles[line][BND_ANG_MIDX] = x;
	lineAngles[line][BND_ANG_MIDY] = y;

	int xv1 = x2 - x;
	int yv1 = y2 - y;

	angle = VectorAngle(xv1 << 16, yv1 << 16);
	angle = ((angle >> 8) + 64);

	lineAngles[line][BND_ANG_ANGLE] = angle;
}

function int GetLineAngle(int line) {
	return toByte(lineAngles[line][BND_ANG_ANGLE]);
}

function bool CheckLineAngle(int x, int y, int angle, int line) {
	int ang, x1, x2, y1, y2, lAngle;
	angle >>= 8;
	ang = angle;

	lAngle = toByte(lineAngles[line][BND_ANG_ANGLE]);

	x >>= 16;
	y >>= 16;

	x1 = GetBoundProperty(line, BND_V1X, curBndMap);
	x2 = GetBoundProperty(line, BND_V2X, curBndMap);

	y1 = GetBoundProperty(line, BND_V1Y, curBndMap);
	y2 = GetBoundProperty(line, BND_V2Y, curBndMap);

	if(lAngle >= 0 && lAngle < 64 ) {
		if(!((x <= x2 || y <= y1) && (x <= x1 || y >= y2)))
			return false;

		if(toByte(ang) >= 0 && toByte(ang) < 64) {
			if(toByte(ang) <= toByte((lAngle + 64)) &&
			toByte(ang) <= toByte((lAngle - 64)))
				return true;
		}
		else if(toByte(ang) >= 64) {
			if(toByte(ang) >= toByte((lAngle + 64)) &&
			toByte(ang) >= toByte((lAngle - 64)))
				return true;
		}
	}

	else if(lAngle >= 64 && lAngle < 127 ) {
		if(!((x <= x2 || y <= y1) && (x >= x1 || y <= y2)))
			return false;
	}

	else if(lAngle >= 127 && lAngle < 191 ) {
		if(!((x >= x2 || y >= y1) && (x >= x1 || y <= y2)))
			return false;
	}

	else if(lAngle >= 191) {
		if(!((x <= x2 || y >= y1) && (x <= x1 || y <= y2)))
			return false;
	}

	if(toByte(ang) <= toByte((lAngle + 64)) &&
		toByte(ang) >= toByte((lAngle - 64)))
		return true;

	return false;
}

function void LoadBoundaries(int map) {
	ACS_Execute(555, 0, map, 0, 0);
}

function bool TryCollide (int tx, int ty, int angle) {
	int dist;
	int i;

	for(int lines = 0; lines < BND_MAX; lines++) {

		if(chkPoints[lines] == 0)
			return false;

		if(CheckLineAngle(tx, ty, angle, lines) == true) {
			for(i = 0; i < chkPoints[lines]; i++) {
				dist = AproxDistance(tx - hitmap[lines][i][0],
					ty - hitmap[lines][i][1]);
				dist >>= 16;
				if(dist <= 24) {
					printbold(s:"Crossed.. ", i:chkPoints[lines], s:" points");
					return true;
				}
			}
		}
	}

	return false;
}

function int GetBoundProperty(int arg1, int arg2, int map) {
	switch(map) {
		case 0:
			return BoundMap00[arg1][arg2];
		case 1:
			return BoundMap01[arg1][arg2];
		case 2:
			return BoundMap02[arg1][arg2];
		case 3:
			return BoundMap03[arg1][arg2];
		case 4:
			return BoundMap04[arg1][arg2];
		case 5:
			return BoundMap05[arg1][arg2];
		case 6:
			return BoundMap06[arg1][arg2];
		case 7:
			return BoundMap07[arg1][arg2];
		case 8:
			return BoundMap08[arg1][arg2];
		case 9:
			return BoundMap09[arg1][arg2];
		case 10:
			return BoundMap10[arg1][arg2];
		case 11:
			return BoundMap11[arg1][arg2];
		case 12:
			return BoundMap12[arg1][arg2];
		case 13:
			return BoundMap13[arg1][arg2];
		case 14:
			return BoundMap14[arg1][arg2];
		case 15:
			return BoundMap15[arg1][arg2];
		case 16:
			return BoundMap16[arg1][arg2];
		case 17:
			return BoundMap17[arg1][arg2];
		case 18:
			return BoundMap18[arg1][arg2];
		case 19:
			return BoundMap19[arg1][arg2];
		case 20:
			return BoundMap20[arg1][arg2];
		case 21:
			return BoundMap21[arg1][arg2];
		case 22:
			return BoundMap22[arg1][arg2];
		case 23:
			return BoundMap23[arg1][arg2];
		case 24:
			return BoundMap24[arg1][arg2];
		case 25:
			return BoundMap25[arg1][arg2];
		case 26:
			return BoundMap26[arg1][arg2];
		case 27:
			return BoundMap27[arg1][arg2];
		case 28:
			return BoundMap28[arg1][arg2];
		default:
			return 0;
	}
	return 0;
}