#define CHAINS	32
int grappleX;
int grappleY;
int grappleZ;
int grappleA;
int grappleT = 0;
int chainTid[CHAINS];

function void GrappleChainTicker (void) {
	int slopex, slopey, slopez;
	int stepx, stepy, stepz;
	int height = plyrZ + (32<<16);

	slopex = grappleX - plyrX;
	slopey = grappleY - plyrY;
	slopez = grappleZ - height;

	if(slopex)
		slopex /= CHAINS;
	if(slopey)
		slopey /= CHAINS;
	if(slopez)
		slopez /= CHAINS;

	stepx = slopex;
	stepy = slopey;
	stepz = slopez;

	for(int i = 0; i < CHAINS; i++) {
		SetActorPosition(chainTid[i], plyrX + stepx + cos (plyrAngle + 0.96) * 4,
			plyrY + stepy + sin (plyrAngle + 0.96) * 4,
			height + stepz, false);
		stepx += slopex;
		stepy += slopey;
		stepz += slopez;
	}
}

function void CreateChains(void) {
	for(int i = 0; i < CHAINS; i++) {
		chainTid[i] = GetAvailableSysTid();
		Spawn("GrappleChain", plyrX, plyrY, plyrZ, chainTid[i], plyrAngle >> 8);
	}
}

function void RemoveChains(void) {
	for(int i = 0; i < CHAINS; i++) {
		Thing_Remove(chainTid[i]);
		chainTid[i] = 0;
	}
}

function void UpdateGrappleCoord (void) {
	grappleX = GetActorX(grappleT);
	grappleY = GetActorY(grappleT);
	grappleZ = GetActorZ(grappleT);
	grappleA = GetActorAngle(grappleT);
}

script 750 (void) {
	grappleT = ActivatorTid();
	CreateChains();
}

script 752 (void) {
	int curX, curY, curZ;
	curX = plyrX;
	curY = plyrY;
	curZ = plyrZ;

	for(int i = 0; i < 4; i++) {
		delay(2);
		if((curX == plyrX && curY == plyrY) || curZ == plyrZ) {
			Terminate751();
		}
	}
}

function void Terminate751(void) {
	TakeInventory("WpnHookChk", 1);
	Thing_Remove(grappleT);
	RemoveChains();
	grappleT = 0;
	ACS_Terminate(751, 0);
}

script 751 (void) {
	int curX, curY, curZ;
	int dist;

	/*if(TryCollide(plyrX, plyrY, plyrAngle))
		Terminate;*/

	GiveInventory("WpnHookChk", 1);

	SpawnMobjMissile("Hook", "weapons/grapple01", true, 0.96, 64, 32, 128);
	delay(1);

	/*if(TryCollide(getActorX(grappleT),
		getActorY(grappleT),
		getActorAngle(grappleT))) {
		TakeInventory("WpnHookChk", 1);
		Terminate751();
	}*/

	while(checkInventory("WpnHookChk")) {
		if(!ThingCount(0, grappleT)) {
			TakeInventory("WpnHookChk", 1);
			break;
		}
		if(A_ReachPlayerLen(grappleX, grappleY) <= 8 ||
			A_ReachPlayerLen(grappleX, grappleY) >= FRACUNITS) {
			Terminate751();
			break;
		}
		curX = grappleX;
		curY = grappleY;
		curZ = grappleZ;
		UpdateGrappleCoord();
		GrappleChainTicker();
		if(A_ReachPlayerLen(grappleX, grappleY) > 8)
			SetActorAngle(0, VectorAngle(grappleX - plyrX, grappleY - plyrY));
		if(curX == grappleX && curY == grappleY) {
			//hasn't moved..
			dist = A_ReachPlayerLen(grappleX, grappleY);
			while(A_ReachPlayerLen(grappleX, grappleY) > 64) {
				for(int i = 0; i < CHAINS; i++) {
					if(ThingCount(0, chainTid[i]) == 0) {
						Terminate751();
					}
				}
				UpdateGrappleCoord();
				GrappleChainTicker();
				ThrustThingZ(0, (grappleZ - plyrZ) >> 16, 0, 0);
				ThrustThing(plyrAngle >> 8, dist);
				ACS_Execute(752, 0, 0, 0, 0);
				delay(1);
			}
			Terminate751();
			break;
		}
		if(A_ReachPlayerLen(grappleX, grappleY) >= 1024) {
			while(A_ReachPlayerLen(grappleX, grappleY) > 64) {
				SetActorAngle(grappleT,
					VectorAngle(plyrX - grappleX, plyrY - grappleY));
				UpdateGrappleCoord();
				GrappleChainTicker();
				ThrustThing(grappleA >> 8, 32, 0, grappleT);
				ThrustThingZ(grappleT, ((plyrZ - grappleZ) >> 16) / 2, 0, 0);
				delay(1);
			}
			Terminate751();
			break;
		}
		delay(1);
	}
}