#library "indexes"
#import "globals.c"
#import "gamfuncs.c"
#include "zcommon.acs"

#define MAXMOBJ	32767

#define TYPE	0
#define	TID		1
#define DIR		2
#define TARG	3
#define TAG		4
#define DEST	5

#define TYPEID	2 //APROP_Damage
#define DIRID	2 //APROP_Damage

int mobjTable[2048][6];	/*Mobj Hash Table*/
int indexDir = 0;	/*Mobj Hash Identifier*/

function int GetAvailableSysTid (void) {
	for(int i = 1; i < MAXMOBJ; i++) {
		if(!thingCount(0, i)) {
			return i;
		}
	}
	return 0;
}

function void ClearRegistry(void) {
	for(int i = 0; i < MAXMOBJ; i++)
		mobjTable[i][TYPE] = -1;
}

function void RegisterMobj(void) {

	if(ActivatorTid())
		return;

	int tTid = GetAvailableSysTid();

	Thing_ChangeTid(0, tTid);

	mobjTable[indexDir][TYPE] = GetActorProperty(0, TYPEID);

	SetActorProperty(0, DIRID, indexDir);

	mobjTable[indexDir][TARG]	= 0;
	mobjTable[indexDir][TID]	= tTid;
	mobjTable[indexDir][DIR]	= indexDir++;
}

script 444 (void) {
	RegisterMobj();
}

function void UnRegisterMobj(void) {
	int index = GetActorProperty(0, DIRID);

	Thing_ChangeTid(_T(index), 0);

	mobjTable[index][TYPE]		= 0;
	mobjTable[index][TID]		= 0;
	mobjTable[index][DIR]		= 0;
	mobjTable[index][TARG]		= 0;
	mobjTable[index][TAG]		= 0;
	mobjTable[index][DEST]		= 0;
}

script 445 (void) {
	UnRegisterMobj();
}

function int GetStack(void) {
	return indexDir;
}

function int _X(int index) {
	return GetActorX(mobjTable[index][TID]);
}

function int _Y(int index) {
	return GetActorY(mobjTable[index][TID]);
}

function int _Z(int index) {
	return GetActorZ(mobjTable[index][TID]);
}

function int _Angle(int index) {
	return GetActorAngle(mobjTable[index][TID]);
}

function int _CZ(int index) {
	return GetActorCeilingZ(mobjTable[index][TID]);
}

function int _Health(int index) {
	return GetActorProperty(mobjTable[index][TID], APROP_Health);
}

function int _Speed(int index) {
	return GetActorProperty(mobjTable[index][TID], APROP_Speed);
}

function int _FZ(int index) {
	return GetActorFloorZ(mobjTable[index][TID]);
}

function int _T(int index) {
	return mobjTable[index][TID];
}

function int _I(void) {
	return MobjTable[GetActorProperty(ActivatorTid(), DIRID)][DIR];
}

function int _TAG(int index) {
	return mobjTable[index][TAG];
}

function int _Type(int index) {
	return mobjTable[index][TYPE];
}

function void SetTag(int index, int value) {
	mobjTable[index][TAG] = value;
}
