//**************************************************************************
//**
//** items.acs : poedDoom
//**$Revise Date: 11/21/06
//**$Author: kaiser
//**$Description: Inventory functions and behavior. Poorly done
//**
//**************************************************************************

#library "items"
#include "zcommon.acs"
#import "globals.c"
#import "gamfuncs.c"
#import "ai.c"
#import "indexes.c"
#include "story.c"
#include "strings.c"

bool isForward = false;

#define M15	0
#define	M25	1
#define M75	2
#define	MBCN	3
#define	MINE	4
#define	GREN	5
#define	REFLECT	6
#define GREN2	7
#define GASG	8
#define FULL2	9
#define FURR	10
#define ARM1	11
#define ARM2	12
#define MCAN	13
#define HFUL	14

#define INV_MAIN 0
#define INV_AMOUNT 1
#define INV_TARGET 2
#define INV_STORE 3
#define INV_ITEMSTORE 4

int friendTag = 8000;
bool beaconActive = false;
int jetPackTics = 0;

//the main inventory slot
int	Inv_PlyrInv[5][15] = { 
	{-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{M15, M25, M75, MBCN, MINE, GREN, REFLECT, GREN2, GASG, FULL2, FURR, ARM1, ARM2, MCAN, HFUL},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1},
	
};

str Inv_Items[15] = {"MedKit15", "MedKit25", "AmmoRefill", "MBeacon", "A_Mine", "I_Grenade",
 "ReflectTrophy", "I_Grenade2", "I_GasCan", "MedKit75", "I_Furry", "I_Armor1", "I_Armor2", "I_MeatAmmo",
 "I_Generate"};

function void ItemTicker(void) {
	loopForItems();
	HandleJetPack();
	jetPackTics = ((jetPackTics + 1) & 15);
}

function int invokeInventory(int a, int b) {
	return Inv_PlyrInv[a][b];
}

function void resetInvVars (void) {
	invCursor = 70.0;
	currentItem = 0;
	idx = 0;
	invActive = false;
	beaconActive = false;
	//canUseInv = false;
}

function void popInventory(int a, int b, int var) {
	Inv_PlyrInv[a][b] = var;
}

function void loopForItems(void) {
	int i;
	if(checkInventory("JetPack")) {
		hasJetpack = true;
	} else { hasJetpack = false; }
	for(i = 0; i < 15; i++) {
		if(checkInventory(Inv_Items[i])) {
			Inv_PlyrInv[INV_AMOUNT][i]++;
			setInventory(i);
			TakeInventory(Inv_Items[i], 1);
		}
	}
}

script 937 (void) {
	if(hasJetpack == true && storyActive == false) {
		throttleCycle++;
		if(throttleCycle > 2) {
			throttleCycle = 0;
		}
	}
}

function void HandleJetPack(void) {
	if(storyActive == true)
		return;
	if(checkInventory("Shell") <= 0) {
		isForward = false;
		throttleCycle = 0;
		SetActorProperty(0, APROP_Speed, FRACUNITS);
	}
	if(hasJetpack == true && checkInventory("Shell") > 0) {
		switch(throttleCycle) {
			case 1:	//full throttle
				if(reflectTics)
					reflectTics = 1;

				if(isForward == false) {
					isForward = true;
					SetActorProperty(0, APROP_Speed, 80*FRACUNITS);
				}
				ThrustThingZ(0, 16, 0, 0);
				if(jetPackTics == 0) {
					ActivatorSound("weapons/jet_thrust", 127);
					TakeInventory("Shell", 2);
				}
				break;
			case 2:	//idle
				ThrustThingZ(0, 4, 1, 0);
				if(jetPackTics == 0) {
					ActivatorSound("weapons/jet_idle", 127);
					TakeInventory("Shell", 2);
				}
				break;
			default:
				isForward = false;
				if(jetPackTics == 0) {
					if(plyrZ > plyrFloorZ) {
						ActivatorSound("weapons/jet_low", 127);
					}
				}
				break;
		}
		if(plyrZ <= plyrFloorZ) {
			isForward = false;
			if(reflectTics > 1)
				SetActorProperty(0, APROP_Speed, 3*FRACUNITS);
			else
				SetActorProperty(0, APROP_Speed, FRACUNITS);
			throttleCycle = 0;
		}
	}
}

function void setInventory(int item) {
	int slot;
	bool inserted = false;
	while(inserted == false) {
		if(Inv_PlyrInv[INV_MAIN][slot] < 0) {
			Inv_PlyrInv[INV_MAIN][slot] = Inv_PlyrInv[INV_TARGET][item];
			inserted = true;
		}
		if(Inv_PlyrInv[INV_MAIN][slot] == item) {
			return;
		}
		slot++;
	}
}

function void removeItem(void) {
	int i;
	if(cheatOn)
	return;
	Inv_PlyrInv[INV_AMOUNT][Inv_PlyrInv[INV_MAIN][currentItem]]--;
	if(Inv_PlyrInv[INV_AMOUNT][Inv_PlyrInv[INV_MAIN][currentItem]] == 0) {
		Inv_PlyrInv[INV_MAIN][currentItem] = -1;
		if(currentItem == gatherItems()) {
			invLeft();
		}
		else {
			Inv_PlyrInv[INV_MAIN][currentItem] = Inv_PlyrInv[INV_MAIN][gatherItems()];
			Inv_PlyrInv[INV_AMOUNT][Inv_PlyrInv[INV_MAIN][currentItem]] = Inv_PlyrInv[INV_AMOUNT][Inv_PlyrInv[INV_MAIN][gatherItems() - 1]];
			Inv_PlyrInv[INV_MAIN][gatherItems() - 1] = -1;
		}
		
	}
}

function void archiveItems(void) {
	int i;
	for(i = 0; i < 15; i++) {
		Inv_PlyrInv[INV_STORE][i] = Inv_PlyrInv[INV_AMOUNT][i];
		Inv_PlyrInv[INV_ITEMSTORE][i] = Inv_PlyrInv[INV_MAIN][i];
	}
}

function void unarchiveItems(void) {
	int i;
	for(i = 0; i < 15; i++) {
		Inv_PlyrInv[INV_AMOUNT][i] = Inv_PlyrInv[INV_STORE][i];
		Inv_PlyrInv[INV_MAIN][i] = Inv_PlyrInv[INV_ITEMSTORE][i];
	}
}

function int gatherItems(void) {
	int slot, amount;
	while(slot <= 16) {
		if(Inv_PlyrInv[INV_MAIN][slot] != -1) {
			amount++;
		}
		slot++;
	}
	return amount - 2;	//don't know how its +2 ahead..
}

function void invLeft(void) {
	if(invOn) {
		if(invPage == 7) {
			invPage = 0;
		}
		return;
	}
	if(invCursor > 70.0 && invActive == true) {
		invRefreshTicker = 20;
		if(idx) {
			currentItem--;
			idx--;
		}
		else {
		invCursor -= 31.0;
		currentItem--;
		}
	}
}

function void invRight(void) {
	if(invOn) {
		if(invPage == 0) {
			invPage = 7;
		}
		return;
	}
	if(invCursor < 163.0 && invActive == true && (currentItem < gatherItems() - 1)) {
		invRefreshTicker = 20;
		invCursor += 31.0;
		currentItem++;
	}
	else if(invActive == true && (currentItem < gatherItems() - 1)) {
		currentItem++;
		idx++;
	}
}

script 801 (void) {
	invLeft();
}

script 802 (void) {
	invRight();
}

script 803 (void) {
	int j = Inv_PlyrInv[INV_MAIN][currentItem];
	str type;
	if(storyActive == true) {
		ACS_Terminate(803, 0);
	}
	switch(j) {
		case 0:
		type = "MedKit15";
		break;
		case 1:
		type = "MedKit25";
		break;
		case 2:
		type = "AmmoRefill";
		break;
		case 3:
		type = "MBeacon";
		break;
		case 4:
		type = "A_Mine";
		break;
		case 5:
		type = "I_Grenade";
		break;
		case 6:
		type = "ReflectTrophy";
		break;
		case 7:
		type = "I_Grenade2";
		break;
		case 8:
		type = "I_GasCan";
		break;
		case 9:
		type = "MedKit75";
		break;
		case 10:
		type = "I_Furry";
		break;
		case 11:
		type = "I_Armor1";
		break;
		case 12:
		type = "I_Armor2";
		break;
		case 13:
		type = "I_MeatAmmo";
		break;
		case 14:
		type = "I_Generate";
		break;
		default:
		type = " ";
		break;
	}
	if(type != " ") {
		A_SpawnInFront(plyrX, plyrY, plyrZ + 32*FRACUNITS, type, plyrAngle, 211, 12);
		if(thingcount(0, 211) > 0) {
			ThrustThing((plyrAngle / 256), 8, 0, 211);
			Thing_ChangeTID (211, 0);
			removeItem();
		}
	}
}

bool shieldactive = false;
script 804 (void) {
	int j = Inv_PlyrInv[INV_MAIN][currentItem];
	int i;
	//why is this not working?
	if(storyActive == false/* && canUseInv == 1*/) {
	switch(j) {
		case 0:
			if(CheckInventory("Health") < 100) {
				HealThing(15);
				removeItem();
			}
		break;
		case 1:
		if(CheckInventory("Health") < 100) {
				HealThing(25);
				removeItem();
			}
		break;
		case 2:
			//ammo refill
			if(!(CheckWeapon(Xweapons[0]) || CheckWeapon(Xweapons[1]) ||
				CheckWeapon(Xweapons[3]))) {
				for(i = 0; i < 10; i++) {
					if(CheckWeapon(Xweapons[i])) {
						GiveInventory(Xammo[i], 999);
					}
				}
				removeItem();
			}
		break;
		case 3:
			//beacon
			if(beaconActive == false) {
				Spawn("MBeacon_Gound", plyrX, plyrY, plyrZ, 212, plyrAngle);
				if(thingcount(0, 212) > 0) {
					beaconActive = true;
					ThrustThing((plyrAngle / 256), 12, 0, 212);
					removeItem();
					ACS_Execute(805, 0, 0, 0, 0);
				}
			}
		break;
		case 4:
			//mine
			A_SpawnInFront(plyrX, plyrY, plyrZ + 32*FRACUNITS, "Mine_Ground", plyrAngle, 211, 12);
			if(thingcount(0, 211) > 0) {
				ThrustThing((plyrAngle / 256), 4, 0, 211);
				Thing_ChangeTID (211, 0);
				removeItem();
			}
		break;
		case 5:
			//grenade
			A_SpawnInFront(plyrX, plyrY, plyrZ + 32*FRACUNITS, "HEGrenade2", plyrAngle, 211, 12);
			if(thingcount(0, 211) > 0) {
				ThrustThing((plyrAngle / 256), 16, 0, 211);
				ThrustThingZ(211, 32, 0, 0);
				Thing_ChangeTID (211, 0);
				removeItem();
			}
		break;
		case 6:
			//trophy
			if(reflectTics <= 0) {
				reflectTics = 1024;
				removeItem();
			}
		break;
		case 7:
			//grenade2
			A_SpawnInFront(plyrX, plyrY, plyrZ + 32*FRACUNITS, "PGrenade2", plyrAngle, 211, 12);
			if(thingcount(0, 211) > 0) {
				ThrustThing((plyrAngle / 256), 16, 0, 211);
				ThrustThingZ(211, 32, 0, 0);
				Thing_ChangeTID (211, 0);
				removeItem();
			}
		break;
		case 8:
			Spawn("GasCan_Ground", plyrX, plyrY, plyrZ, 211, plyrAngle);
			if(thingcount(0, 211) > 0) {
				ThrustThing((plyrAngle / 256), 12, 0, 211);
				Thing_ChangeTID (211, 0);
				removeItem();
			}
		break;
		case 9:
		if(CheckInventory("Health") < 100) {
				HealThing(75);
				removeItem();
			}
		break;
		case 10:
			for(i = 65; i < 115; i++) {
				if(reflectTics) {
					A_SpawnInFront(plyrX, plyrY, plyrZ + 32*FRACUNITS, "PorkFX", plyrAngle, 211, 32);
				}
				else { A_SpawnInFront(plyrX, plyrY, plyrZ + 32*FRACUNITS, "PorkFX", plyrAngle, 211, 18); }
				if(reflectTics) {
					ThrustThing((GetActorAngle(211) / 256 + 90) - i, 128, 1, 211);
				}
				else { ThrustThing((GetActorAngle(211) / 256 + 90) - i, 64, 1, 211); }
				Thing_ChangeTID (211, 0);
			}
			removeItem();
		break;
		case 11:
			if(CheckInventory("Armor") < 100) {
				GiveInventory("GreenArmor", 1);
				removeItem();
			}
		break;
		case 12:
			if(CheckInventory("Armor") < 200) {
				GiveInventory("BlueArmor", 1);
				removeItem();
			}
		break;
		case 13:
			if(shieldactive == false) {
				shieldactive = true;
				Spawn("Meat_Ground", plyrX, plyrY, plyrZ, 215, plyrAngle);
				if(thingcount(0, 215) > 0) {
					ThrustThing((plyrAngle / 256), 12, 0, 215);
					removeItem();
				}
				else { shieldactive = false; }
			}
		break;
		case 14:
			if(regenTics <= 0) {
				regenTics = 2048;
				removeItem();
			}
		break;
		default:
		break;
	}
	}
}

script 807 (void) {
	givingFuel = true;
	delay(1);
	givingFuel = false;
}

script 806 (void) {
	Spawn("TurretFriend", GetActorX(215), GetActorY(215), GetActorZ(215), 0, 0);
	Spawn("TeleportFog", GetActorX(215), GetActorY(215), GetActorZ(215), 0, 0);
	Thing_ChangeTID (215, 7000);
	shieldactive = false;
}

script 805 (void) {
	int k = 5;
	int i = 0.9;
	int j = 0;
	delay(2*35);	//wait until the beacon is still
	while(k != 0) {
		if(getActorZ(212) == GetActorFloorZ(212)) {
			Spawn("MarineAlly_Test", GetActorX(212), GetActorY(212), GetActorZ(212), 213, 0);
			if(thingcount(0, 213) > 0) {
				k--;
				Spawn("TeleportFog", GetActorX(212), GetActorY(212), GetActorZ(212), 0, 0);
				if(friendSpecial == false)
					Thing_ChangeTID (213, _T(GetStack()));
				else
					Thing_ChangeTID (213, friendTag++);
				delay(3*35);
			}
		}
		delay(1);
	}
	SetActorProperty(212,APROP_RenderStyle,64);
	for(j = 1; j < 10; j++) {
		SetActorProperty(212,APROP_Alpha, i);
		i -= 0.1;
		delay(10);
	}
	Thing_Remove(212);
	//Thing_ChangeTID (212, 0);
	delay(1*35);
	beaconActive = false;
}

/**********************************************************************************
937:	Advance key. In gameplay mode, toggle jetpack, in story mode, advance to next page
938:	Handle jetpack functions and behavior
801:	Move inventory cursor to the left
802:	Move inventory cursor to the right
803:	Drop inventory
804:	Use inventory
807:	Fuel refill (from fuel stations)
806:	Spawn a friendly turret
805:	Marine Friend beacon ticker. Pauses if player is standing on the beacon.
***********************************************************************************/
