//**************************************************************************
//**
//** macros.acs : poedDoom
//**$Revise Date: 11/19/06
//**$Author: kaiser
//**$Description: Triggering things / sequences
//**
//**************************************************************************

#library "macros"
#include "zcommon.acs"

/****************************************************
***************Animated Switches*********************
*****************************************************/

/*	arg0 = Floor Height (0-999)
	arg1 = Ceiling Height (0-999)
	arg2 = Sector Light (0-255)
	arg3 = Floor Height2 (0-99)
	arg4 = Ceiling Height2 (0-99)*/

/*	x = tag
	y = id
	z = tex*/

#define SWARG0		0
#define SWARG1		1
#define SWARG2		2
#define SWARG3		3
#define SWARG4		4
str darksw01[2][5] = {
	{ "ANIMSW01", "ANIMSW02", "ANIMSW03", "ANIMSW04", "ANIMSW05" },
	{ "ANIMSW01", "ANIMSW02", "ANIMSW03", "ANIMSW04", "ANIMSW05" }
};
int swArg[256][5];
bool swRepeat[256];

function void setupSwitch (int tag, int tex, int id) {
	swArg[id][SWARG0] = ((GetSectorFloorZ(tag, 0, 0) >> 16) / 100);
	swArg[id][SWARG1] = ((GetSectorCeilingZ(tag, 0, 0) >> 16) / 100);
	swArg[id][SWARG2] = GetSectorLightLevel(tag);
	swArg[id][SWARG3] = ((GetSectorFloorZ(tag, 0, 0) >> 16) 
		- (swArg[id][SWARG0] * 100));
	swArg[id][SWARG4] = ((GetSectorCeilingZ(tag, 0, 0) >> 16)
		- (swArg[id][SWARG1] * 100));

	swRepeat[id] = true;
	setlinespecial(id, ACS_Execute, 233, 0, id, tex, 0);
}

script 233 (int id, int tex) {
	int i;

	if(swRepeat[id] == true) {

		LocalAmbientSound("menu/activate", 127);
		if(tex < 100) {
			for(i = 0; i < 5; i++) {
				setlinetexture(id, SIDE_FRONT, TEXTURE_MIDDLE, darksw01[tex][i]);
				delay(4);
			}
			performSwitch(id);
			swRepeat[id] = false;
		}
		else {
			for(i = 0; i < 5; i++) {
				setlinetexture(id, SIDE_FRONT, TEXTURE_MIDDLE, darksw01[tex-100][i]);
				delay(4);
			}
			performSwitch(id);
			delay(25);
			for(i = 4; i >= 0; i--) {
				setlinetexture(id, SIDE_FRONT, TEXTURE_MIDDLE, darksw01[tex-100][i]);
				delay(4);
			}
		}
	}
	tagwait(swArg[id][SWARG1]);
}

script 234 (void) {
	int x = getActorX(0) >> 16;
	int y = getActorY(0) >> 16;
	int z = getActorZ(0) >> 16;
	setupSwitch(x, z, y);
}

function void performSwitch(int id) {
	switch(swArg[id][SWARG0]) {
		case 80:
			break;
		case 81:
			break;
		case 82:
			break;
		case 83:
			break;
		case 84:
			break;
		case 10:
			break;
		case 11:
			break;
		case 12:
			break;
		case 20:
			break;
		case 36:
				Floor_LowerByValueTimes8(swArg[id][SWARG1],
					swArg[id][SWARG2], swArg[id][SWARG3]);
			break;
		case 66:
			break;
		case 68:
			break;
		case 21:
			break;
		case 22:
			break;
		case 23:
			break;
		case 35:
			break;
		case 67:
			break;
		case 24:
			break;
		case 25:
			break;
		case 95:
			break;
		case 96:
			break;
		case 112:
			break;
		case 62:
			break;
		case 63:
			break;
		case 64:
			break;
		case 65:
			break;
		case 33:
			break;
		case 34:
			break;
		case 226:
			break;
		default:
			print(s:"Unknown type: ", i: id);
			break;
	}
}

/*function void testSwitch(int id, int arg) {
	printbold(i: swArg[id][arg]);
}*/

/****************************************************
***************Sector Controllers********************
*****************************************************/

script 232 (void) {
	int tag = (GetActorZ(0) >> 16);
	int rotate = ActivatorTID();

	Sector_SetRotation(tag, 0, rotate);
}

script 231 (void) {
	int tag = (GetActorZ(0) >> 16);
	int rotate = ActivatorTID();

	Sector_SetRotation(tag, rotate, 0);
}

script 230 (void) {
	int x = (GetActorX(0) >> 16);
	int y = (GetActorY(0) >> 16);
	int tag = ActivatorTID();

	if(GetActorProperty(0, APROP_Ambush))
		Sector_SetFloorPanning(tag, x % 64 * -1, x % 64 * -1,
		y % 64, y % 64);
	else Sector_SetFloorPanning(tag, x, x, y, y);
}

script 229 (void) {
	int x = (GetActorX(0) >> 16);
	int y = (GetActorY(0) >> 16);
	int tag = ActivatorTID();

	if(GetActorProperty(0, APROP_Ambush))
		Sector_SetCeilingPanning(tag, x % 64 * -1, x % 64 * -1,
		y % 64, y % 64);
	else Sector_SetCeilingPanning(tag, x, x, y, y);
}

/**********************************************************************************
233:	Setup switch
234:	Aquire data to setup switch based on the thing macro
232:	Rotate
231:	Rotate
230:	Panning
229:	Panning
***********************************************************************************/

