//**************************************************************************
//**
//** inventory.acs : poedDoom
//**$Revise Date: 3/9/08
//**$Author: kaiser
//**$Description: inventory and hud drawer
//**
//**************************************************************************
//inventory and hud functions - Samuel Villarreal 8/2005

/*12-05-05: Inventory functions added. Implented hud system*/
/*3-01-06: Updated drawing functions, added jetpack drawer*/
/*11-21-06: Ported to library/cleaned up*/

#library "hudfonts"
#include "zcommon.acs"
#import "globals.c"
#import "gamfuncs.c"
#import "tables.c"
#import "ai.c"
#import "weapons.c"
#import "items.c"
#include "story.c"
#include "strings.c"

int Iammo[10] = {0, 0, 15, 0, 40, 40, 10, 32, 24, 100 };
int Imin[10] = {0, 0, 300, 0, 400, 100, 150, 300, 300, 150};
int invSwitch = 0;
str newIcons[15] = {"I_HPK1", "I_HPMP", "I_AFUL", "I_BEAC", "I_MINE", "I_GRAP", "I_REFL", "I_GRN2",
"I_GASG", "I_FULL", "I_FURR", "I_ARM1", "I_ARM2", "I_PDMB", "I_HFUL"};
str specialItems[2] = {"I_ENTR", "ARTISOAR"};
#define INVBACK 100000
#define HUDBACK 1000000
#define COIN 200
#define FULL 300
#define BEAC 400
#define JET 500
#define PERCENTVALUE1 201
#define PERCENTVALUE2 301
#define PERCENTVALUE3 401
#define PERCENTVALUE4 501
#define INVNUM1 2000
#define INVNUM2 3000
#define INVNUM3 4000
#define WTIMER 9300
int iconID[4] = {COIN, FULL, BEAC, JET};
int iconPercent[4] = {PERCENTVALUE1, PERCENTVALUE2, PERCENTVALUE3, PERCENTVALUE4};
int iconID_X[8] = {180.0, 180.0, 180.0, 180.0, 240.0, 240.0, 240.0, 240.0 };
int iconID_Y[8] = {100.0, 120.0, 140.0, 160.0, 100.0, 120.0, 140.0, 160.0 };
int iconID_P[8] = {195.0, 195.0, 195.0, 195.0, 255.0, 255.0, 255.0, 255.0 };
int iconID_Numbers[8] = {205.0, 205.0, 205.0, 205.0, 265.0, 265.0, 265.0, 265.0};
int iconID_Misc_X[2] = {240.0, 272.0};
int iconID_Misc_Y[2] = {140.0, 140.0};
str invNumbers[10] = { "INV0","INV1","INV2","INV3","INV4","INV5","INV6","INV7","INV8","INV9"};
str invWeapons[10] = { "I_WPN1","I_WPN2","I_WPN3","I_WPN4","I_WPN5","I_WPN6","I_WPN7","I_WPN8",
"I_WPN9","I_WPN10"};
int wpnID_X[10] = {55.0, 55.0, 55.0, 55.0, 90.0, 90.0, 90.0, 90.0, 120.0, 120.0 };
int wpnID_Y[10] = {100.0, 120.0, 140.0, 165.0, 100.0, 120.0, 140.0, 165.0, 100.0, 120.0 };
int objOrder = 0;
str objPicText = "";
#define XOBJTITLE 9000
#define XOBJBRIEF 9100
#define XOBJPIC 9500
#define STOPIT 802
str specialStuff[4] = {"CleaverSpecial", "ShockSpecial", "PanSpecial", "FlameSpecial"};
str specialIcons[4] = {"I_CSPEC", "I_SSPEC", "I_PSPEC", "I_FSPEC"};
int specialID_X[4] = {120.0, 140.0, 120.0, 140.0 };
int specialID_Y[4] = {140.0, 140.0, 160.0, 160.0};
#define MODVAL 10
int timerY;
int hours;
int minutes;
int seconds;
str ammoPic[10] = {"", "", "PCELA0", "", "PCL2A0", "PBATA0", "CROKA0", "PCELA0", "PCELA0", "CROKA0"};
int ammoPicY[10] = {0, 0, 548.0, 0, 532.0, 548.0, 564.0, 548.0, 548.0, 564.0};
int currentTimer;
str jetPackAnimation[9] = { "JET1A0","JET1B0","JET1C0","JET1D0","JET1E0",
"JET1F0","JET1G0","JET1H0","JET1I0"};
int subSequence;

#define INV_MAIN3 0
#define INV_AMOUNT3 1
#define INV_TARGET3 2
#define INV_STORE3 3
#define INV_ITEMSTORE3 4

									/*Inventory stuff goes here*/
//turn on/off the inventory chart
script 800 (void) {
	if(storyActive == true) {
		invOn = 0;
		invSwitch = 0;
		ACS_Terminate(800, 0);
	}
	if(invSwitch == 0) {
		invOn = 1;
		invSwitch = 1;
	}
	else if(invSwitch == 1) {
		invOn = 2;
		invSwitch = 2;
	}
	else {
		invOn = 0;
		invSwitch = 0;
	}
}
//draw the chart
function void HudTicker(void) {
	if(GetLevelInfo(LEVELINFO_LEVELNUM) == 1 || 
		GetLevelInfo(LEVELINFO_LEVELNUM) == 35)
		return;
	drawFrame();
	drawPowerupText();
	drawJetPackIcon();
	if(invOn)
		SetHudSize(320, 240, 0);
	switch(invOn) {
		case 1:
			drawInventory();
			drawIcons();
			drawWeapons();
			//drawMiscItems();
			break;
		case 2:
			drawInventory();
			drawObjectives(objOrder, objPicText);
			drawWorldTimer();
			break;
	}
}

//draw inventory background
function void drawInventory(void) {
	SetFont("invchart");
	hudmessage(s:"a"; HUDMSG_PLAIN, INVBACK, CR_UNTRANSLATED, 0.5, 0.5, 0.1);
}

//draw icons from inventory items and the number amount
function void drawIcons(void) {
	int i, numHum, randomStuff;
	SetFont("I_TITLE");
	hudmessage(s:"a"; HUDMSG_PLAIN, INVBACK - 1, CR_UNTRANSLATED, 160.0, 44.0, 0.1);
	if(invPage == 0) {
		if(CheckInventory("Coin")) {
			SetFont("I_COIN");
			hudmessage(s:"a"; HUDMSG_PLAIN, 250, CR_UNTRANSLATED, iconID_X[0], iconID_Y[0], 0.1);
			SetFont("inv%");
			hudmessage(s:"a"; HUDMSG_PLAIN, iconPercent[0], CR_UNTRANSLATED, iconID_P[0], iconID_Y[0], 0.1);
			drawInvNumber(CheckInventory("Coin"), iconID_Numbers[0], iconID_Y[0], 0);
		}
	}
	if(!invPage)
		randomStuff = 0;
		else randomStuff = 1;
	for(i = invPage; i < 7 + invPage + randomStuff; i++) {
		if(invPage == 0) {
			numHum = i + 1;
		}
		else if(invPage == 7) {
			numHum = i - 7;
		}
		if(invokeInventory(INV_AMOUNT3, i)) {
			SetFont(newIcons[i]);
			hudmessage(s:"a"; HUDMSG_PLAIN, 400 + (200 * (i - invPage)), CR_UNTRANSLATED, iconID_X[numHum], iconID_Y[numHum], 0.1);
			SetFont("inv%");
			hudmessage(s:"a"; HUDMSG_PLAIN, iconPercent[numHum], CR_UNTRANSLATED, iconID_P[numHum], iconID_Y[numHum], 0.1);
			drawInvNumber(invokeInventory(INV_AMOUNT3, i), iconID_Numbers[numHum], iconID_Y[numHum], numHum);
		}
	}
}

//draws them silly weapons
function void drawWeapons(void) {
	int i;
	for(i = 0; i < 10; i++) {
		if(CheckInventory(Xweapons[i])) {
			SetFont(invWeapons[i]);
			hudmessage(s:"a"; HUDMSG_PLAIN, 10 + i, CR_UNTRANSLATED, wpnID_X[i], wpnID_Y[i], 0.1);
		}
	}
	for(i = 0; i < 4; i++) {
		if(CheckInventory(specialStuff[i])) {
			SetFont(specialIcons[i]);
			hudmessage(s:"a"; HUDMSG_PLAIN, 1111+i, CR_UNTRANSLATED, specialID_X[i], specialID_Y[i], 0.1);
		}
	}
}

//draw other stuff
/*function void drawMiscItems(void)
{
	int i;
	for (i = 0; i < 2; i++)
	{
		if(CheckInventory(specialKeys[i]))
		{
			SetFont(specialItems[i]);
			hudmessage(s:"a"; HUDMSG_PLAIN, 1000 + Xweapons[i], CR_UNTRANSLATED, iconID_Misc_X[i], iconID_Misc_Y[i], 0.1);
		}
	}
}*/

function void updateObjectives(int pos, str pic, bool alert) {
	objOrder = pos;
	objPicText = pic;
	if(alert)
	printbold(s:"ATTN: Objectives has been updated!!");
}

function void drawWorldTimer(void) {
	int main;
	main = timer() + currentTimer;
	main /= 35;
	hours = main / 3600;
	main -= hours * 3600;
	minutes = main / 60;
	main -= minutes * 60;
	seconds = main;
	SetFont("CONFONT");
	hudmessage(i:hours,s:":", i: (minutes / 10), i:(minutes % 10),
	s:":", i:(seconds / 10), i:(seconds % 10); HUDMSG_PLAIN, WTIMER, CR_GREEN, 220.0, timerY, 0.1);
}

function void ArchiveTimer(int map) {
	int current = timer() + currentTimer;
	ACS_Execute(777, map, current);
}

function void UnArchiveTime(int c) {
	currentTimer = c;
}

script 777 (int current) {
	UnArchiveTime(current);
}

//draw objectives
function void drawObjectives(int position, str pic) {
	drawObjectiveText(position);
	SetFont(pic);
	SetHudSize(320, 240, 0);
	if(strlen(pic) == 0) {
		hudmessage(s:""; HUDMSG_PLAIN, XOBJPIC, CR_UNTRANSLATED, 220.0, 128.0, 0.1);
		timerY = 128.0;
	}
	else {
		hudmessage(s:"a"; HUDMSG_PLAIN, XOBJPIC, CR_UNTRANSLATED, 220.0, 128.0, 0.1);
		timerY = 174.0;
	}
}

function void drawObjectiveText(int position) {
	int i, k, width, len, rewind;
	int posName = 160.0;
	int posObjX = 52.0, posObjY = 112.0;
	int sizeofName, sizeofObj;
	bool lineCrossed = false;
	decodeDialogStr(position, false);
	while(1) {
		if(lvlString[i] == '\0' || i >= 32)
		break;
		i++;
		posName -= 3.5;
	}
	sizeofName = i;
	i = 0;
	decodeDialogStr(position, true);
	while(1) {
		if(lvlString[i] == '\0' || i >= 256)
		break;
		i++;
	}
	sizeofObj = i;
	i = 0;
	SetHudSize(320, 240, 0);
	decodeDialogStr(position, false);
	SetFont("CONFONT");
	for(k = 0; k < sizeofName; k++) {
		hudmessage(c:lvlString[k]; HUDMSG_PLAIN, XOBJTITLE + k, CR_GOLD, posName, 42.0, 0.1);
		posName += 8.0;
	}
	k = 0;
	SetHudSize(432, 288, 0);
	decodeDialogStr(position, true);
	while(k < sizeofObj) {
		if(sizeofObj > 16 && lineCrossed == false) {
			while(lvlString[k + len] != ' ' && len <= 16) {
				len++;
			}
			while(lvlString[k + len--] != ' ') {
				rewind++;
			}
			len = len - rewind;
		}
		lineCrossed = true;
		hudmessage(c:lvlString[k]; HUDMSG_PLAIN, XOBJBRIEF + k,
		CR_GOLD, posObjX, posObjY, 0.1);
		k++;
		width++;
		posObjX += 8.0;
		if((width >= (16 - len) && lvlString[k] == ' ') || lvlString[k] == '\n') {
			posObjY += 10.0;
			posObjX = 52.0;
			width = 0;
			while(1) {
				if(lvlString[k] != ' ')
				break;
				else k++;
			}
			lineCrossed = false;
		}
		len = 0;
	}
}

//draws the numbers for each amount of a item
function void drawInvNumber (int number, int x, int y, int type) {
	int mVal, i, loop, xVal;
	int val = 10;
	int j = 10;
	int o = 1;
	bool foundNum = false;
	while(foundNum == false) {
		loop++;
		if(number < val) {
			foundNum = true;
		}
		val *= MODVAL;
	}
	SetFont(invNumbers[number % 10]);
	hudmessage(s:"a"; HUDMSG_PLAIN, INVNUM1 + type, CR_UNTRANSLATED, x + ((7.0 * loop) - 7.0), y, 0.1);
	if(loop >= 2) {
		SetFont(invNumbers[number / (val / 100)]);
		hudmessage(s:"a"; HUDMSG_PLAIN, INVNUM2 + type, CR_UNTRANSLATED, x, y, 0.1);
	}
	if(loop >= 3) {
		for(i = 2; i < loop; i++) {
			xVal += 7.0;
		}
		for(i = 2; i < loop; i++) {
			j *= MODVAL;
			o *= MODVAL;
			mVal += (INVNUM3 + 100);
			SetFont(invNumbers[(number % j) / o]);
			hudmessage(s:"a"; HUDMSG_PLAIN, mVal + type, CR_UNTRANSLATED, x + xVal, y, 0.1);
			xVal -= 7.0;
		}
	}
}
									/*Hud stuff goes here*/
function void drawHudWidget(int x, int y, str type, int sequence, int min, int max, int bx, int by) {
	int condition;
	int order = sequence;
	str hth;
	int a = CheckInventory(type);
	if(CheckInventory(type) <= 40) {
			condition = CR_RED;
			hth = "ST_RHLTH";
		}
		else if(CheckInventory(type) <= min) {
			condition = CR_GREEN;
			hth = "ST_GHLTH";
		}
		else if(CheckInventory(type) > min) {
			condition = CR_GOLD;
			hth = "ST_LHLTH";
		}
		SetFont("SMALLFONT");
		SetHudSize(400, 280, 0);
		hudmessage(i:CheckInventory(type); HUDMSG_PLAIN, HUDBACK - order, condition, x, y, 0.1);
		order += 2;
		/*SetHudSize(healthTable[health], 150, 0);*/
		SetHudSize(680, 150, 0);
		SetFont(hth);
		if(CheckInventory(type) >= 1) {
			if(CheckInventory(type) >= max + 1) {
				SetFont("ST_GFULL");
				if(getCvar("screenblocks") == 11)
				hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - order, CR_UNTRANSLATED,
				(bx + 47.0), by, 0.1);
			}
			if(CheckInventory(type) >= min + 1) {
				if(getCvar("screenblocks") == 11)
				hudmessage(s:meterList[CheckInventory(type) * 100 / min - 100]; HUDMSG_PLAIN, HUDBACK - order, CR_UNTRANSLATED,
				(bx + 100.0 - a), by, 0.1);
				order -= 1;
				SetFont("ST_GFULL");
				if(getCvar("screenblocks") == 11)
				hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - order, CR_UNTRANSLATED,
				(bx + 47.0), by, 0.1);
			}
			if(CheckInventory(type) <= min) {
				if(type == "Health" && condition == CR_RED) {
					if(timer() & 16)
					if(getCvar("screenblocks") == 11)
					hudmessage(s:meterList[CheckInventory(type) * 100 / min]; HUDMSG_PLAIN, HUDBACK
					- order, CR_UNTRANSLATED, (bx + 100.0 - a), by, 0.1);
				}
				else {
				if(getCvar("screenblocks") == 11)
				hudmessage(s:meterList[CheckInventory(type) * 100 / min]; HUDMSG_PLAIN, HUDBACK - order, CR_UNTRANSLATED,
				(bx + 100.0 - a), by, 0.1);
				}
			}
		}
}

function void ProTipHandle(void) {
	SetHudSize(320, 200, 0);
	SetFont("CONFONT");
	hudmessage(s:"ProTip: setting screenblocks to 11\n in the console makes\n this message go away!";
	HUDMSG_PLAIN, HUDBACK, CR_RED, 160.0, 128.0, 0.1);
}

function void HealthHandle(void) {
	SetHudSize(800, 600, 0);
	SetFont("PBAR");
//	if(getCvar("screenblocks") == 11)
		hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK, CR_UNTRANSLATED, 655.0, 48.0, 0.1);
		drawHudWidget(268.0, 10.0, "Health", 1, 100, 200, 488.0, 5.0);
}

function void ArmorHandle(void) {
	SetHudSize(800, 600, 0);
	SetFont("XBAR");
//	if(getCvar("screenblocks") == 11)
		hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - 4, CR_UNTRANSLATED, 96.0, 580.0, 0.1);
	drawHudWidget(14.0, 271.0, "Armor", 5, 100, 200, 56.0, 145.0);
	SetHudSize(800, 600, 0);
	SetFont("PARMB0");
//	if(getCvar("screenblocks") == 11)
		hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - 8, CR_UNTRANSLATED, 232.0, 604.0, 0.1);
}

function void AmmoHandle(void) {
	int i;
	if(!(CheckWeapon(Xweapons[0]) || CheckWeapon(Xweapons[1]) ||
		CheckWeapon(Xweapons[3]))) {
		SetHudSize(800, 600, 0);
		SetFont("XBAR");
//		if(getCvar("screenblocks") == 11)
		hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - 9, CR_UNTRANSLATED, 96.0, 524.0, 0.1);
		for(i = 0; i < 10; i++) {
			if(CheckWeapon(Xweapons[i])) {
				drawHudWidget(14.0, 245.0, Xammo[i], 10, Imin[i], Imin[i]*2, 56.0, 131.0);
				SetHudSize(800, 600, 0);
				if(i == 6 && CheckInventory("RocketProjSwap"))
					SetFont("GGBLC0");
				else
					SetFont(ammoPic[i]);
//				if(getCvar("screenblocks") == 11)
					hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - 14,
					CR_UNTRANSLATED, 224.0, ammoPicY[i], 0.1);
			}
		}
	}
}

function void drawFrame(void) {
	if(invOn)
		return;
	if(getCvar("screenblocks") < 11) {
		ProTipHandle();
		return;
	}
	if(getCvar("screenblocks") > 10) {
		HealthHandle();
		ArmorHandle();
		AmmoHandle();
		drawHINV_Coin();
		drawHINV_Bar();
	}
	if(invRefreshTicker)
		invRefreshTicker--;
}

function void drawJetPackIcon(void) {
	int colors;
	SetHudSize(640, 480, 0);
	if(hasJetPack == true && getCvar("screenblocks") == 11) {
		SetFont("CONFONT");

			if(checkInventory("Shell") >= 50)
				colors = CR_GREEN;
			else colors = 6;

			hudmessage(i: (checkInventory("Shell") / 2); HUDMSG_PLAIN,
				HUDBACK - 50, colors, 72.0, 32.0, 0.1);

		if(plyrZ == plyrFloorZ) {
			subSequence = 0;
			SetFont("JETSA0");
			hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - 16, CR_UNTRANSLATED, 36.0, 36.0, 0.1);
		}
		else {
			switch(throttleCycle) {
				case 0:
				animateJetIcon(6);
				break;
				case 1:
				animateJetIcon(0);
				break;
				case 2:
				animateJetIcon(3);
				break;
			}
		}
	}
}

function void animateJetIcon(int sequence) {
	SetHudSize(640, 480, 0);
	SetFont(jetPackAnimation[(sequence + subSequence)]);
	hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - 16, CR_UNTRANSLATED, 36.0, 44.0, 0.1);
	if((timer() & 3) == 0) {
		subSequence++;
		if(subSequence > 2) {
			subSequence = 0;
		}
	}
}

									/*OnScreen Inventory stuff goes here*/

function void drawHINV_Coin(void) {
//	if(getCvar("screenblocks") == 11) {
		SetHudSize(640, 480, 0);
		SetFont("IBAR");
		hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - 19, CR_UNTRANSLATED, 614.0, 465.0, 0.1);
		SetHudSize(320, 240, 0);
		SetFont("I_COIN");
		hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - 18, CR_UNTRANSLATED, 306.0, 232.0, 0.1);
		SetHudSize(640, 480, 0);
		SetFont("IBARBACK");
		hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - 17, CR_UNTRANSLATED, 614.0, 465.0, 0.1);
		SetHudSize(400, 280, 0);
		SetFont("SMALLFONT");
		if(CheckInventory("Coin") >= 101) {
			hudmessage(i:CheckInventory("Coin"); HUDMSG_PLAIN, HUDBACK - 20, CR_GREEN,
			394.0 - (GetNotation(CheckInventory("Coin")) / 50), 256.0, 0.1);
		} else {hudmessage(i:CheckInventory("Coin"); HUDMSG_PLAIN, HUDBACK - 20, CR_GREEN, 384.0, 256.0, 0.1); }
	//}
}

function void drawHINV_Bar(void) {
	int i;
	invActive = false;
	//if(getCvar("screenblocks") == 11) {
		SetHudSize(800, 600, 0);

		SetFont("XBAR");
		hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - 21, CR_UNTRANSLATED, 96.0, 552.0, 0.1);
		SetFont("IBAR2");
		hudmessage(s:"a"; HUDMSG_PLAIN, HUDBACK - 22, CR_UNTRANSLATED, invCursor, 552.0, 0.1);

		for(i = 0; i < 15; i++) {
			if(invokeInventory(INV_AMOUNT3, i)) {
				invActive = true;
				SetHudSize(400, 280, 0);
				SetFont("SMALLFONT");
				if(cheatOn == false) {
					hudmessage(i:invokeInventory(INV_AMOUNT3, invokeInventory(INV_MAIN3, currentItem)); HUDMSG_PLAIN, HUDBACK - 31,
					CR_GREEN, 14.0, 258.0, 0.1);
				}
				else {
					if(timer() & 16) {
						hudmessage(i:999; HUDMSG_PLAIN, HUDBACK - 31, CR_GREEN, 14.0, 258.0, 0.1);
					}
				}
			}
		}
		drawHINV_Icons();
	//}
}

function void drawHINV_Icons(void) {
	int bx = 0.0;
	str ifont;
	int item = 0;
	int i, amount, slot;
	int pos = 23;
	SetHudSize(800, 600, 0);
	for(i = 0; i < 4; i++) {
		item = invokeInventory(INV_MAIN3, i+idx);
		if(item >= 0)
		{
			SetFont(newIcons[item]);
			ifont = "a";
		}
		else ifont = " ";

		if(getCvar("screenblocks") == 11)
		{
			hudmessage(s:ifont; HUDMSG_PLAIN, HUDBACK - pos, CR_UNTRANSLATED, 70.0 + bx, 552.0, 0.1);
		}
		else
		{
			if(invRefreshTicker > 0)
			{
				hudmessage(s:ifont; HUDMSG_PLAIN, HUDBACK - pos, CR_UNTRANSLATED, 70.0 + bx, 552.0, 0.1);
			}
		}
		bx += 31.0;
		pos++;
	}
}

function void drawPowerupText(void) {
	if(regenTics) {
		if(regenTics < 128) {
			if(timer() & 16) {
				SetHudSize(800, 600, 0);
				SetFont("SMALLFONT");
				hudmessage(s:"Regenerating"; HUDMSG_PLAIN, HUDBACK - 33, CR_ORANGE, 756.0, 128.0, 0.1);
			}
		}
		else {
			SetHudSize(800, 600, 0);
			SetFont("SMALLFONT");
			hudmessage(s:"Regenerating"; HUDMSG_PLAIN, HUDBACK - 33, CR_ORANGE, 756.0, 128.0, 0.1);
		}
	}
	if(reflectTics) {
		if(reflectTics < 256) {
			if(timer() & 16) {
				SetHudSize(800, 600, 0);
				SetFont("SMALLFONT");
				hudmessage(s:"Speed Active"; HUDMSG_PLAIN, HUDBACK - 32, CR_YELLOW, 756.0, 112.0, 0.1);
			}
		}
		else {
			SetHudSize(800, 600, 0);
			SetFont("SMALLFONT");
			hudmessage(s:"Speed Active"; HUDMSG_PLAIN, HUDBACK - 32, CR_YELLOW, 756.0, 112.0, 0.1);
		}
	}
	if(poisTics) {
		if(poisTics < 64) {
			if(timer() & 16) {
				SetHudSize(800, 600, 0);
				SetFont("SMALLFONT");
				hudmessage(s:"Poisoned"; HUDMSG_PLAIN, HUDBACK - 34, CR_GREEN, 756.0, 144.0, 0.1);
			}
		}
		else {
			SetHudSize(800, 600, 0);
			SetFont("SMALLFONT");
			hudmessage(s:"Poisoned"; HUDMSG_PLAIN, HUDBACK - 34, CR_GREEN, 756.0, 144.0, 0.1);
		}
	}
	if(leakTics) {
		if(leakTics < 64) {
			if(timer() & 16) {
				SetHudSize(800, 600, 0);
				SetFont("SMALLFONT");
				hudmessage(s:"Leaking"; HUDMSG_PLAIN, HUDBACK - 35, CR_GRAY, 756.0, 160.0, 0.1);
			}
		}
		else {
			SetHudSize(800, 600, 0);
			SetFont("SMALLFONT");
			hudmessage(s:"Leaking"; HUDMSG_PLAIN, HUDBACK - 35, CR_GRAY, 756.0, 160.0, 0.1);
		}
	}
}

/**********************************************************************************
800:	Main hud responder (keys)
799:	Main hud drawing ticker
777:	Restore timer
***********************************************************************************/
