//**************************************************************************
//**
//** story.acs : poedDoom
//**$Revise Date: 11/19/05
//**$Author: kaiser
//**$Description: On screen dialog behavior
//**
//**************************************************************************

#include "acsStrings.acs"

bool storyActive = false;
bool clearFonts = false;
bool canAdvance = false;
int cameraSequence = 0, numStory = 0;
int trim[3] = { 0, 0, 0 };
#define WINDOW 65000	//note a single row in window can hold 38 fonts per row (4 total). Only 152 characters can be displayed total
#define NAMEROW	WINDOW + 1000
#define ROW1	WINDOW + 2000
#define ROW2	WINDOW + 3000
#define ROW3	WINDOW + 4000
#define ROW4	WINDOW + 5000

int lvlString[256];

function void clearDialogStr (void) {
	for (int i = 0; i < 256; i++)
		lvlString[i] = 0;
}

function int getDialogLength (int pos, bool fullText) {
	int i = 0;
	if(fullText == false) {
		while(1) {
			if(strName[pos][i] == 0)
				break;
			if(i == 8)
				break;
			i++;
		}
	}
	else {
		while(1) {
			if(strText[pos][i] == 0)
				break;
			if(i == 63)
				break;
			i++;
		}
	}
	return i;
}

function void decodeDialogStr (int pos, bool fullText) {
	int i, k;
	int data;
	clearDialogStr();
	if(fullText == false) {
		for(i = 0; i < getDialogLength(pos, fullText); i++) {
			data = strName[pos][i];
			data = data ^ 16;
			lvlString[k++] = data & 255;
			lvlString[k++] = data >> 8 & 255;
			lvlString[k++] = data >> 16 & 255;
			lvlString[k++] = data >> 24 & 255;
		}
	}
	else {
		for(i = 0; i < getDialogLength(pos, fullText); i++) {
			data = strText[pos][i];
			data = data ^ 16;
			lvlString[k++] = data & 255;
			lvlString[k++] = data >> 8 & 255;
			lvlString[k++] = data >> 16 & 255;
			lvlString[k++] = data >> 24 & 255;
		}
	}
	
}

script 501 (int pos, int numSequence, int dTic) {
	int nameLen = 0, i, textLen = 0, k, j, p, x;
	int nPosX = 80.0, tPosY = 308.0, tPosX = 156.0;
	LockPlayer();
	delay(dTic);
	storyActive = true;
	bool foundSpecial = false;
	cameraSequence = 0;
	while(numSequence != 0) {
		numStory = numSequence;
		while(clearFonts == false) {
			SetHudSize(640, 480, 0);
			SetFont("DBOXTOP");
			hudmessage(s:"a"; HUDMSG_PLAIN, WINDOW, CR_UNTRANSLATED, 320.0, 348.0, 0.1);
			nPosX = 80.0;
			nameLen = 0;
			p = 0;
			decodeDialogStr(pos, false);
			if(lvlString[0] == '#') {
				for(p = 0; p < 16; p++) {
					lvlString[p] = WorldStrName[p];
				}
				p = 0;
			}
			while(1) {
				if(lvlString[nameLen] == '\0' || nameLen >= 24)
				break;
				nameLen++;
			}
			i = 0;
			SetHudSize(320, 240, 0);
			for(i = 0; i < nameLen; i++) {
				SetFont(sFontTable[lvlString[i]]);
				hudmessage(s:"a"; HUDMSG_PLAIN, NAMEROW + i, CR_UNTRANSLATED, nPosX, 135.0, 0.1);
				nPosX += 9.0;
			}
			SetHudSize(640, 480, 0);
			k = 0;
			tPosX = 156.0;
			textLen = 0;
			for(i = 0; i < 256; i++) {
				tempStr[i] = 0;
			}
			i = 0;
			x = 0;
			decodeDialogStr(pos, true);
			while(lvlString[p] != '\0') {
				tempStr[x] = lvlString[p];
				if(tempStr[x] == '#') {
					foundSpecial = true;
					for(i = 0; i < 16; i++) {
						if(WorldStrName[i] != '\0') {
							tempStr[x] = WorldStrName[i];
							x++;
						}
					}
					x-=1;
					
				}
				x++;
				p++;
			}
			p = 0;
			x = 0;
			if(foundSpecial == true) {
				for(i = 0; i < 256; i++) {
					lvlString[i] = '\0';
				}
				while(tempStr[p] != '\0') {
					lvlString[p] = tempStr[p];
					p++;
				}
			}
			foundSpecial = false;
			while(1) {
				if(lvlString[textLen] == '\0' || textLen >= 256)
				break;
				textLen++;
			}
			//now see if the string is over 38 characters. If so then trim it and fit the rest in the second row and so on.
			trim[0] = 0; trim[1] = 0; trim[2] = 0;
			if(textLen > 38) {
				while(textLen > 38 || lvlString[textLen] != ' ') {
					textLen--;
					trim[0]++;
				}
			}
			//snip snip snip
			if(trim[0] > 38) {
				while(trim[0] > 38 || lvlString[textLen+trim[0]] != ' ') {
					trim[0]--;
					trim[1]++;
				}
			}
			if(trim[1] > 38) {
				while(trim[1] > 38 || lvlString[textLen+trim[0]+trim[1]] != ' ') {
					trim[1]--;
					trim[2]++;
				}
			}
			
			for(k = 0; k < textLen; k++) {
				if(sFontTable[lvlString[k]] == ']' || sFontTable[lvlString[k]] == '^')
					LocalAmbientSound("other/lollers", 127);

				SetFont(sFontTable[lvlString[k]]);
				hudmessage(s:"a"; HUDMSG_PLAIN, ROW1 + k, CR_UNTRANSLATED, tPosX, tPosY, 0.1);
				tPosX += 9.0;
			}
			if(trim[0] != 0) {
				tPosX = 156.0;
				for(k = textLen + 1; k < textLen + trim[0]; k++) {
					if(sFontTable[lvlString[k]] == ']' || sFontTable[lvlString[k]] == '^')
						LocalAmbientSound("other/lollers", 127);
					SetFont(sFontTable[lvlString[k]]);
					hudmessage(s:"a"; HUDMSG_PLAIN, ROW2 + k, CR_UNTRANSLATED, tPosX, tPosY + 23.0, 0.1);
					tPosX += 9.0;
				}
			}
			if(trim[1] != 0) {
				tPosX = 156.0;
				for(k = textLen + trim[0] + 1; k < textLen + trim[0] + trim[1]; k++) {
					if(sFontTable[lvlString[k]] == ']' || sFontTable[lvlString[k]] == '^')
						LocalAmbientSound("other/lollers", 127);
					SetFont(sFontTable[lvlString[k]]);
					hudmessage(s:"a"; HUDMSG_PLAIN, ROW3 + k, CR_UNTRANSLATED, tPosX, tPosY + 46.0, 0.1);
					tPosX += 9.0;
				}
			}
			if(trim[2] != 0) {
				tPosX = 156.0;
				for(k = textLen + trim[0] + trim[1] + 1; k < textLen + trim[0] + trim[1] + trim[2]; k++) {
					if(sFontTable[lvlString[k]] == ']' || sFontTable[lvlString[k]] == '^')
						LocalAmbientSound("other/lollers", 127);
					SetFont(sFontTable[lvlString[k]]);
					hudmessage(s:"a"; HUDMSG_PLAIN, ROW4 + k, CR_UNTRANSLATED, tPosX, tPosY + 69.0, 0.1);
					tPosX += 9.0;
				}
			}
			if(numSequence > 1) {
				if(timer() & 16) {
					SetFont("CONFONT");
					hudmessage(s:"-->"; HUDMSG_PLAIN, WINDOW + 1, CR_GOLD, 480.0, 390.0, 0.1);
				}
			}
			canAdvance = true;
			delay(1);
		}
		numSequence--;
		cameraSequence++;
		pos += 1;
		clearFonts = false;
	}
	UnLockPlayer();
	ChangeCamera(0, 1, 0);
	canAdvance = false;
	storyActive = false;
}

function void doStoryAdvance(void) {
	if(canAdvance)
	clearFonts = true;
}

function void doStory(int p, int e, int t) {
	ACS_Execute(501, 0, p, e, t);
}

script 556 (void) {
	if(storyActive == true) {
		doStoryAdvance();
	}
}