#library "dialogs"
#import "globals.c"
#import "gamfuncs.c"
#include "zcommon.acs"
#include "strfile.c"

#define MAXNODES		768
#define MAXNAMECHAR		32
#define MAXSTRCHAR		256

int filePointer = 3;
int bytePointer = -1;
int symbol[MAXSTRCHAR];
int treeSize[MAXNODES];
int codeData[MAXSTRCHAR];

int storyName[MAXNAMECHAR];

int wldStrPos = 0;

function void clearNameStr (void) {
	for(int i = 0; i < MAXNAMECHAR; i++)
		storyName[i] = ' ';
}

function void TrimName(void) {
	for(int i = 0; i < MAXNAMECHAR; i++) {
		if(storyName[i] == ' ' && storyName[i+1] == ' ') {
			storyName[i] = '\0';
			break;
		}
	}
}

function void AssembleName(int index) {
	int k = 0;
	int pos = 0;
	int treeIdx;
	int dat = 0;
	int bit = 0;
	clearNameStr();

	for(int i = 0; i < 8; i++) {
		if(nameList[index][i] == -1)
			break;

		pos = nameList[index][i] & ((1 << 16) - 1);
		treeIdx = nameList[index][i] >> 16;

		for(k = 0; k < 8; k++) {
			if(nameTree[treeIdx][k] == 0)
				break;

			for(bit = 0; bit <= 24; bit += 8) {
				if(bit >= 32)
					break;

				if(bit == 0)
					dat = nameTree[treeIdx][k] & 255;
				else
					dat = nameTree[treeIdx][k] >> bit & 255;

				if(dat)
					storyName[pos++] = dat;
				else
					break;
			}
		}
	}
	TrimName();
}

function int File_NextByte(void) {
	filePointer = (filePointer + 1) & 3;

	if(!filePointer) {
		bytePointer++;
	}

	return ((strDat[bytePointer] >> ((filePointer) * 8)) & 255);
}

function void DialogInit(void) {
	int dirSize;
	int treeMax;

	if(GetLevelInfo(LEVELINFO_LEVELNUM) > 0) {
		LockPlayer();
	}

	if(File_NextByte() == 'D' && File_NextByte() == 'I' && File_NextByte() == 'R')
		dirSize = File_NextByte();
	else {
		printbold(s:"File_Open: Header not found");
		return;
	}

	for(int i = 0; i < dirSize; i++) {
		symbol[i] = File_NextByte();
	}

	if(File_NextByte() == 'X' && File_NextByte() == 'S' && File_NextByte() == 'T'
		&& File_NextByte() == 'R') {
		treeMax = File_NextByte();
		treeMax |= ((File_NextByte()) << 8);
	}
	else {
		printbold(s:"File_Open: String Header not found");
		return;
	}

	for(i = 0; i < treeMax; i++) {
		treeSize[i] = File_NextByte();
	}

	ACS_Execute(999, 0, treeMax, 0, 0);
}

script DECOMPRESSOR (int treeMax) {
	int index, getidbyte, lookupid, strPos, bits, k, i;
	int per = 0;

	for(index = 0; index < treeMax; index++) {
		getidbyte = 0;
		lookupid = 0;
		strPos = 0;

		printbold(s:"Loading: ", i: (fixedDiv(per, treeMax) * 100) >> 16, s:"%");

		WorldStrPos[index] = wldStrPos;

		for(i = 0; i < MAXSTRCHAR; i++) {
			codeData[i] = 0;
		}

		k = 0;
		bits = 0;

		do {
			if(!bits)
				lookupid = File_NextByte();

			bits = (bits + 1) & 7;

			if(lookupid & 1)
				codeData[k++] = 0x00;
			else
				codeData[k++] = File_NextByte();

			lookupid = lookupid >> 1;

		} while(k < treeSize[index]);

		lookupid = 0;

		for(i = 0; i < treeSize[index]; i++) {
			for(k = 0; k < 8; k++) {
				if(getidbyte == 0) {
					lookupid = ((codeData[i] >> k) & 1);
					getidbyte++;
				}
				else {
					if(((codeData[i] >> k) & 1) == 0)
						getidbyte++;
					else {
						WorldStrData[wldStrPos++] =
							symbol[((getidbyte-1) << 1) + lookupid];
						strPos++;
						getidbyte = 0;
					}
				}
			}
		}
		WorldStrSize[index] = strPos;
		per++;
		if(index && index % 16 == 0)
			delay(1);
	}

	if(GetLevelInfo(LEVELINFO_LEVELNUM) > 0) {
		UnLockPlayer();
	}
	printbold(s:"Done");
}
