//**************************************************************************
//**
//** users.acs : poedDoom
//**$Revise Date: 11/21/06
//**$Author: kaiser
//**$Description: Player Functions
//**
//**************************************************************************

#library "users"
#include "zcommon.acs"
#import "globals.c"
#import "items.c"
#include "strings.c"

function void PlayerTicker(void) {
	UpdatePlayerInfo();
	UpdateFuelStation();
	UpdateSpeedTrophy();
	UpdateRegeneration();
	UpdateIncubusBite();
	UpdatePdemonBite();
	UpdatePoison();
	UpdateLeak();
	UpdatePanSpecial();
}

function void UpdatePlayerInfo(void) {
	plyrX = GetActorX(0);
	plyrY = GetActorY(0);
	plyrZ = GetActorZ(0);
	plyrFloorZ = GetActorFloorZ(0);
	plyrAngle = GetActorAngle(0);
	plyrPitch = GetActorPitch(0);
	plyrCeilingZ = GetActorCeilingZ(0);
}

//remove special tokens upon each map load
function void RefreshPlayerInfo(void) {
	unarchiveItems();
	TakeInventory("SpecialItem", 1);
	TakeInventory("SpecialItem2", 1);
	TakeInventory("SpecialItem3", 1);
	TakeInventory("SpecialItem4", 1);
	TakeInventory("QuestItem14", 1);
	SetActorProperty(0, APROP_Speed, FRACUNITS);
	reflectTics = 0;
}

function void UpdateFuelStation(void) {
	if(givingFuel == true) {
		GiveInventory("NewShell", 4);
	}
}

function void UpdateSpeedTrophy(void) {
	if(reflectTics > 0) {
		reflectTics--;
	}
	if(reflectTics > 1) {
		SetActorProperty(0, APROP_Speed, 3*FRACUNITS);
	} else if(reflectTics == 1){
		SetActorProperty(0, APROP_Speed, FRACUNITS); }
}

function void UpdateRegeneration(void) {
	if(regenTics > 0) {
		regenTics--;
		if(timer() % 32 == 14) {
			LocalAmbientSound("weapons/regeneration", 127);
			HealThing(5);
		}
	}
}

function void UpdateIncubusBite(void) {
	if(bitByIncubus == true) {
		GiveInventory("Status_Poison", 1);
		GiveInventory("Status_Leak", 1);
		printbold(s:"You've contracted Incubus' disease!");
		bitByIncubus = false;
	}
}

function void UpdatePdemonBite(void) {
	if(bitByPdemon == true && leakTics == 0) {
		GiveInventory("Status_Leak", 1);
		bitByPdemon = false;
	}
}

function void UpdatePoison(void) {
	if(poisTics == 1) { TakeInventory("Status_Poison", 1); poisTics = 0; }
	if(checkInventory("Status_Poison")) {
		if(poisTics == 0) {
			if(random(0, 127) < 64) {
				poisTics = 500;
			}
			else { TakeInventory("Status_Poison", 1); poisTics = 0; } 
		}
		if(poisTics > 0) {
			poisTics--;
			if(timer() % 32 == 14) {
				DamageThing(Random(1, 2));
			}
		}
	}
}

function void UpdateLeak(void) {
	int i;
	if(leakTics == 1) { TakeInventory("Status_Leak", 1); leakTics = 0; }

	if(checkInventory("Status_Leak")) {
		if(leakTics == 0) {
			leakTics = 400;
		}
		if(leakTics > 0) {
			leakTics--;
			if(timer() % 32 == 14) {
				for(i = 0; i < 10; i++) {
					if(Xammo[i] != "Fist") {
						TakeInventory(Xammo[i], 1);
					}
				}
			}
		}
	}
}

function void UpdatePanSpecial(void) {
	if(checkInventory("PanSpecial")) {
		if(checkInventory("Health") < 40 && checkInventory("FuckingRaged") == 0) {
			GiveInventory("FuckingRaged", 1);
		}
		else if(checkInventory("Health") > 40 && checkInventory("FuckingRaged")) {
			fadeto (0, 0, 255, 0.0, 0.0);
			TakeInventory("FuckingRaged", 1);
		}
		if(checkInventory("FuckingRaged") && CheckWeapon(Xweapons[0])) {
			if(timer() & 16)
			fadeto (0, 0, 255, 0.3, 0.0);
			else
			fadeto (0, 0, 255, 0.0, 0.0);
		} else { fadeto (0, 0, 255, 0.0, 0.0); }
	}
}