//**************************************************************************
//**
//** weapons.acs : poedDoom
//**$Revise Date: 11/21/06
//**$Author: kaiser
//**$Description: Weapon functions / transfering features
//**
//**************************************************************************

#library "weapons"
#include "zcommon.acs"
#include "strings.c"
#import "globals.c"
#import "tables.c"
#import "indexes.c"
#import "gamfuncs.c"
#import "boundaries.c"

#include "drill.c"
#include "camMissile.c"
#include "shockgun.c"
#include "snipeGun.c"
#include "graphook.c"

str DoomWeapons[9] = {"Fist", "Pistol", "Shotgun", "SuperShotgun", "Chaingun",
 "RocketLauncher", "PlasmaRifle", "BFG9000", "Chainsaw"};

function void WeaponTicker(void) {
	checkShockCharge();
	loopForWeapons();
}

function int findWeapon(int a, int b)
{
	if((a & b) != 0) { return 1; } return 0;
}

script 252 (int a) {
	weaponNum = a;
}

function void loopForWeapons(void) {
	int i;
	for(i = 0; i < 9; i++) {
		TakeInventory(DoomWeapons[i], 1);
	}
}

script 882 (void) {
	int i = 0;
	int x, y;
	while(i++ < 80) {
		x = GetActorX(0);
		y = GetActorY(0);
		if(GetActorZ(0) <= GetActorFloorZ(0)) {
			SetActorAngle(0, GetActorAngle(0) + (random(-112, 112) << 8));
			ThrustThing(GetActorAngle(0) >> 8, 48);
			ThrustThingZ(0, 64, 0, 0);
			Spawn("Naplam_Boom", getActorX(0), getActorY(0), getActorZ(0),
				0, getActorAngle(0) >> 8);
		}
		delay(1);
		if(x == GetActorX(0) && y == GetActorY(0))
			ThrustThing((GetActorAngle(0) >> 8) + 128, 48);
	}
}

script 883 (void) {
	SpawnMobjMissile("Naplam", "weapons/rocket2", true, 0.92, 64, 24, 48);
	delay(1);
}

/**********************************************************************************
252:	Assign weaponNum
950:	Shockgun charge special
951:	Shockgun charge ticker
952:	Clear Shockgun charges
669:	Drill splatter function
665:	Hand wipe drawer
933:	Missile Cam function
934:	Missile Cam explosion
935:	Move Cam up
936:	Move Cam down
900:	Missile Cam weapon zoom
***********************************************************************************/
