//-------------------------------------------------------------------------
// STRMAKE - String to ascii char converter
// Turns a simple string into a per integer block array for Zdoom ACS scripting
// Primary used for Community is Falling 3 (Kaiser_21.wad)
//
// (c) 11/15/2005 Samuel 'Kaiser' Villarreal
//
//--------------------------------------------------------------------------
#include <stdio.h>
#include <io.h>
#include <string.h>
#include <stdlib.h>

char * buffer;
char * endBuffer;
typedef unsigned char byte;
int slot = 0;
//on screen text
#define MAXARRAY 1100	
char Name[MAXARRAY][32];	//character name string
char Text[MAXARRAY][256];	//dialog text string
//I want my booleans! >:(
typedef enum {
	false,
	true
} bool_t;

void K_OpenFile(char* input) {
	long lSize;
	FILE* f;
	f = fopen ( input , "rb" );
	if (f==NULL) exit (1);
	fseek (f , 0 , SEEK_END);
	lSize = ftell (f);
	rewind (f);
	buffer = (char*) malloc (lSize + 1);
	if (buffer == NULL) exit (2);
	endBuffer = buffer + lSize;
	fread (buffer,1,lSize,f);
	fclose (f);
}

void K_MakeACSArray(char* input) {
	FILE* f;
	int i, k;
	int len, nameData;
	byte nameEx;
	char* newFile = input+strlen(input)-1;
	while(newFile != input) {
		if(*newFile == 0x5c)
		{
			newFile++;
			*newFile = '\0';
			break;
		}
		newFile--;
	}
	strcat(input, "acsStrings.acs");
	f = fopen(input, "w");
	if (f==NULL) {
		printf("Read Error..\n");
		exit (1);
	}
	fprintf(f, "//Text file generated by STRMAKE.exe\n\n");
	fprintf(f, "//Names\n");
	for(i = 0; i < slot; i++) {
		//write name
		len = strlen(Name[i]);
		nameEx = len % 4;

		len += nameEx;

		if(i == 0) fprintf(f, "int strName[%i][8] = {\n", slot);


		fprintf(f, "/*%s*/\n\t\t", Name[i]);

		for(k = 0; k < 28; k+=4) {
			if(k == 0) fprintf(f, "	{ ");
			nameData = 
			((Name[i][k])|((Name[i][k+1])<<8)|((Name[i][k+2])<<16)|((Name[i][k+3])<<24));
			nameData = nameData ^ 16;	//scramble it
			(k >=24) ? fprintf(f, "%i }", nameData) :
				fprintf(f, "%i,", nameData);
		}
		i >= slot-1 ? fprintf(f, "\n};\n") : fprintf(f, ",\n");
	}
	fprintf(f, "\n\n//Strings\n");
	for(i = 0; i < slot; i++) {
		//write text
		len = strlen(Text[i]);
		nameEx = len % 4;

		len += nameEx;

		if(i == 0) fprintf(f, "int strText[%i][63] = {\n", slot);


		fprintf(f, "/*%s*/\n\t\t", Text[i]);

		for(k = 0; k < 252; k+=4) {
			if(k == 0) fprintf(f, "	{ ");
			nameData = 
			((Text[i][k])|((Text[i][k+1])<<8)|((Text[i][k+2])<<16)|((Text[i][k+3])<<24));
			nameData = nameData ^ 16;	//scramble it
			(k >=248) ? fprintf(f, "%i }", nameData) :
				fprintf(f, "%i,", nameData);
		}
		i >= slot-1 ? fprintf(f, "\n};\n") : fprintf(f, ",\n");
	}
	newFile = 0;
	fclose(f);
}

int main(int argc, char**argv)
{
	int pos = 0;
	int i;
	bool_t foundToken = false;
	if(argc == 1 || argc > 2) {
		printf("STRMAKE by Samuel 'Kaiser' Villarreal - Usage: STRMAKE.exe 'location of file'\n");
		return 1;
	}
	K_OpenFile(argv[1]);
	for(i = 0; i < 256; i++) {
		memset(Name, 0, sizeof(Name[i]));
		memset(Text, 0, sizeof(Text[i]));
	}
	printf("============================\nSTRMAKE by Samuel 'Kaiser' Villarreal\n============================\nReading file...\n");
	while(buffer < endBuffer) {
		if(*buffer <= 32) {
			buffer++;
		}
		else if(*buffer == '$') {
			foundToken = true;
			//bypass '$'
			buffer++;
			while(*buffer != '=') {
				if(pos > sizeof(Name) / 256) {
					printf("String is too long..\n");
					exit(1);
				}
				if(*buffer < 32) {
					printf("String Error..\n");
					exit(1);
				}
				Name[slot][pos] = *buffer;
				pos++;
				buffer++;
			}
			//bypass '='
			buffer++;
			pos = 0;
			while(*buffer >= 32) {
				if(pos > sizeof(Text) / 256) {
					printf("String is too long..\n");
					exit(1);
				}
				Text[slot][pos] = *buffer;
				pos++;
				buffer++;
			}
			pos = 0;
			slot++;
			foundToken = false;
		}
		else if(*buffer == '\n') {
			buffer++;
		}
		else {
			printf("Unknown token found..\n");
			exit(1);
		}
	}
	buffer = 0;
	free (buffer);
	K_MakeACSArray(argv[1]);
	printf("Done..%i array slots left\n", MAXARRAY - slot * 2);
	return 0;
}