#define __ENCODERS__
#ifdef	__ENCODERS__

/*__________________________________________________________________
Typedefs
____________________________________________________________________*/

typedef unsigned char byte;
typedef unsigned int uint;
typedef unsigned short ushort;
typedef enum { false, true } bool_t;

/*__________________________________________________________________
Const Defines
____________________________________________________________________*/

#define MAXSLOTS	768
#define	MAXSYMBOLS	60
#define	MAXBITS		30

/*__________________________________________________________________
Code structures
____________________________________________________________________*/

typedef struct {
	char nameTree[32];
	int count;
	char cpyName[32];
	int treeIndex[8];
} nameTree_t;

typedef struct {
	byte symbol[256];
	int count[256];
	byte codeString[MAXSLOTS][256];
	int index[256];
	byte dirSize;
	byte strSize[MAXSLOTS];
	int max;
} strTree_t;

/*__________________________________________________________________
Externs
____________________________________________________________________*/

extern int slot;
extern char Name[MAXSLOTS][32];	//character name string
extern char Text[MAXSLOTS][256];	//dialog text string

extern int match;
extern int listPos;

extern nameTree_t nameTree[MAXSLOTS];
extern strTree_t strTree;

/*__________________________________________________________________
Prototypes
____________________________________________________________________*/

void K_SortStrTree(void);
void K_MakeStrTree(void);
int K_FindString(char* name, char* text, bool_t checkName);
void K_InsertNameIndex(int index);
void K_AssembleNames(void);
void K_OpenStrTree(char* bin);
void K_CreateNameDir(void);
void K_SetupStrTree(void);
void K_TestNames(void);

#endif /*__ENCODERS__*/
